/* sudoku-cell.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <pango/pango.h>

#define SUDOKU_CELL_size_ratio 2
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_POPOVER_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL,
	SUDOKU_CELL_NUM_SIGNALS
};
static guint sudoku_cell_signals[SUDOKU_CELL_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint row;
	gint col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkEventControllerKey* key_controller;
	GtkPopover* _popover;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean control_key_pressed;
};

struct _Block10Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* earmark_picker;
};

struct _Block11Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* number_picker;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* gesture,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* gesture,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean sudoku_cell_key_pressed_cb (SudokuCell* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void sudoku_cell_key_released_cb (SudokuCell* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state);
static void _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self);
VALA_EXTERN GtkPopover* sudoku_cell_get_popover (SudokuCell* self);
static void __lambda10_ (SudokuCell* self);
static void ___lambda10__gtk_popover_closed (GtkPopover* _sender,
                                      gpointer self);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
static void sudoku_cell_get_visible_earmarks (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_earmark (SudokuCell* self,
                                 gint num,
                                 gboolean enabled);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint num,
                                         gboolean enabled);
static void sudoku_cell_get_visible_earmark (SudokuCell* self,
                                      gint num);
static gint sudoku_cell_get_key_number (SudokuCell* self,
                                 guint keyval);
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN gboolean number_picker_get_is_earmark_picker (NumberPicker* self);
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
static void sudoku_cell_show_number_picker (SudokuCell* self);
static void sudoku_cell_show_earmark_picker (SudokuCell* self);
VALA_EXTERN void sudoku_cell_initialize_earmarks (SudokuCell* self,
                                      gboolean show_possibilities);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN NumberPicker* number_picker_new (SudokuGame* game,
                                 gboolean for_earmarks);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuGame* game,
                                       gboolean for_earmarks);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
static void __lambda9_ (Block10Data* _data10_,
                 gint number,
                 gboolean state);
static void ___lambda9__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda8_ (Block11Data* _data11_,
                 NumberPicker* o,
                 gint number);
static void ___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_show_warnings (SudokuCell* self);
static gboolean sudoku_cell_warn_incorrect_solution (SudokuCell* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_show_extra_warnings (SudokuCell* self);
static void sudoku_cell_real_dispose (GObject* base);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel** label,
                                gint font_size);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_background (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 137 "../src/sudoku-cell.vala"
	return self ? g_object_ref (self) : NULL;
#line 313 "sudoku-cell.c"
}

void
sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                   gint val,
                                   gboolean enabled)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	GtkLabel* earmark = NULL;
	GtkLabel** _tmp3_;
	gint _tmp3__length1;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 132 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 134 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 134 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 134 "../src/sudoku-cell.vala"
	if (!sudoku_board_is_earmark_enabled (_tmp2_, self->priv->row, self->priv->col, val)) {
#line 135 "../src/sudoku-cell.vala"
		return;
#line 342 "sudoku-cell.c"
	}
#line 137 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->earmark_labels;
#line 137 "../src/sudoku-cell.vala"
	_tmp3__length1 = self->priv->earmark_labels_length1;
#line 137 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_[val - 1];
#line 137 "../src/sudoku-cell.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 137 "../src/sudoku-cell.vala"
	earmark = _tmp5_;
#line 138 "../src/sudoku-cell.vala"
	if (enabled) {
#line 356 "sudoku-cell.c"
		GtkLabel* _tmp7_;
#line 138 "../src/sudoku-cell.vala"
		_tmp7_ = earmark;
#line 138 "../src/sudoku-cell.vala"
		_tmp6_ = !gtk_widget_has_css_class ((GtkWidget*) _tmp7_, "error");
#line 362 "sudoku-cell.c"
	} else {
#line 138 "../src/sudoku-cell.vala"
		_tmp6_ = FALSE;
#line 366 "sudoku-cell.c"
	}
#line 138 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 370 "sudoku-cell.c"
		GtkLabel* _tmp8_;
#line 139 "../src/sudoku-cell.vala"
		_tmp8_ = earmark;
#line 139 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "highlight-label");
#line 376 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp9_;
#line 141 "../src/sudoku-cell.vala"
		_tmp9_ = earmark;
#line 141 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp9_, "highlight-label");
#line 383 "sudoku-cell.c"
	}
#line 132 "../src/sudoku-cell.vala"
	_g_object_unref0 (earmark);
#line 387 "sudoku-cell.c"
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 194 "../src/sudoku-cell.vala"
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
#line 398 "sudoku-cell.c"
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 195 "../src/sudoku-cell.vala"
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
#line 410 "sudoku-cell.c"
}

static gboolean
_sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_cell_key_pressed_cb ((SudokuCell*) self, keyval, keycode, state);
#line 196 "../src/sudoku-cell.vala"
	return result;
#line 424 "sudoku-cell.c"
}

static void
_sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                    guint keyval,
                                                                    guint keycode,
                                                                    GdkModifierType state,
                                                                    gpointer self)
{
#line 197 "../src/sudoku-cell.vala"
	sudoku_cell_key_released_cb ((SudokuCell*) self, keyval, keycode, state);
#line 436 "sudoku-cell.c"
}

static void
__lambda10_ (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 222 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 222 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 222 "../src/sudoku-cell.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 222 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 222 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 456 "sudoku-cell.c"
		GtkPopover* _tmp4_;
		GtkPopover* _tmp5_;
#line 224 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_popover (self);
#line 224 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 224 "../src/sudoku-cell.vala"
		gtk_popover_set_child (_tmp5_, NULL);
#line 225 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 467 "sudoku-cell.c"
	}
}

static void
___lambda10__gtk_popover_closed (GtkPopover* _sender,
                                 gpointer self)
{
#line 221 "../src/sudoku-cell.vala"
	__lambda10_ ((SudokuCell*) self);
#line 477 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame** game)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkEventController* _tmp13_;
	GtkGestureLongPress* _tmp14_;
	GtkEventController* _tmp15_;
	GtkEventControllerKey* _tmp16_;
	GtkEventController* _tmp17_;
	GtkGestureClick* _tmp18_;
	GtkGestureLongPress* _tmp19_;
	GtkGestureLongPress* _tmp20_;
	GtkGestureClick* _tmp21_;
	GtkEventControllerKey* _tmp22_;
	GtkEventControllerKey* _tmp23_;
	GtkLabel* _tmp24_;
	gint num = 0;
	GtkPopover* _tmp46_;
	GtkPopover* _tmp47_;
	GtkEventControllerKey* popover_controller = NULL;
	GtkEventControllerKey* _tmp48_;
	GtkEventControllerKey* _tmp49_;
	GtkEventControllerKey* _tmp50_;
	GtkWidget* _tmp51_ = NULL;
	GtkPopover* _tmp52_;
	GtkPopover* _tmp53_;
	GtkPopover* _tmp56_;
	GtkPopover* _tmp57_;
#line 167 "../src/sudoku-cell.vala"
	g_return_val_if_fail (*game != NULL, NULL);
#line 167 "../src/sudoku-cell.vala"
	self = (SudokuCell*) g_object_new (object_type, NULL);
#line 169 "../src/sudoku-cell.vala"
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
#line 171 "../src/sudoku-cell.vala"
	self->priv->row = row;
#line 172 "../src/sudoku-cell.vala"
	self->priv->col = col;
#line 173 "../src/sudoku-cell.vala"
	_tmp0_ = _g_object_ref0 (*game);
#line 173 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 173 "../src/sudoku-cell.vala"
	self->priv->game = _tmp0_;
#line 175 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 175 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 175 "../src/sudoku-cell.vala"
	if (_tmp2_ != 0) {
#line 540 "sudoku-cell.c"
		GtkLabel* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
#line 177 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->value_label;
#line 177 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_value (self);
#line 177 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 177 "../src/sudoku-cell.vala"
		_tmp6_ = g_strdup_printf ("%i", _tmp5_);
#line 177 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 177 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp3_, _tmp7_);
#line 177 "../src/sudoku-cell.vala"
		_g_free0 (_tmp7_);
#line 178 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->value_label;
#line 178 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 565 "sudoku-cell.c"
	}
#line 181 "../src/sudoku-cell.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 182 "../src/sudoku-cell.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 184 "../src/sudoku-cell.vala"
	_tmp9_ = sudoku_cell_get_is_fixed (self);
#line 184 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_;
#line 184 "../src/sudoku-cell.vala"
	if (_tmp10_) {
#line 185 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
#line 579 "sudoku-cell.c"
	}
#line 187 "../src/sudoku-cell.vala"
	_tmp11_ = self->priv->button_controller;
#line 187 "../src/sudoku-cell.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp11_, (guint) 0);
#line 189 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->button_controller;
#line 189 "../src/sudoku-cell.vala"
	_tmp13_ = _g_object_ref0 ((GtkEventController*) _tmp12_);
#line 189 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp13_);
#line 190 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->long_press_controller;
#line 190 "../src/sudoku-cell.vala"
	_tmp15_ = _g_object_ref0 ((GtkEventController*) _tmp14_);
#line 190 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp15_);
#line 191 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->key_controller;
#line 191 "../src/sudoku-cell.vala"
	_tmp17_ = _g_object_ref0 ((GtkEventController*) _tmp16_);
#line 191 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp17_);
#line 192 "../src/sudoku-cell.vala"
	_tmp18_ = self->priv->button_controller;
#line 192 "../src/sudoku-cell.vala"
	_tmp19_ = self->priv->long_press_controller;
#line 192 "../src/sudoku-cell.vala"
	gtk_gesture_group ((GtkGesture*) _tmp18_, (GtkGesture*) _tmp19_);
#line 194 "../src/sudoku-cell.vala"
	_tmp20_ = self->priv->long_press_controller;
#line 194 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp20_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 195 "../src/sudoku-cell.vala"
	_tmp21_ = self->priv->button_controller;
#line 195 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp21_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
#line 196 "../src/sudoku-cell.vala"
	_tmp22_ = self->priv->key_controller;
#line 196 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp22_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 197 "../src/sudoku-cell.vala"
	_tmp23_ = self->priv->key_controller;
#line 197 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp23_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 199 "../src/sudoku-cell.vala"
	_tmp24_ = self->priv->value_label;
#line 199 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp24_, (GtkWidget*) self);
#line 201 "../src/sudoku-cell.vala"
	num = 0;
#line 631 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 202 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 636 "sudoku-cell.c"
		{
			gboolean _tmp25_ = FALSE;
#line 202 "../src/sudoku-cell.vala"
			_tmp25_ = TRUE;
#line 202 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 643 "sudoku-cell.c"
				SudokuBoard* _tmp27_;
				SudokuBoard* _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
#line 202 "../src/sudoku-cell.vala"
				if (!_tmp25_) {
#line 650 "sudoku-cell.c"
					gint _tmp26_;
#line 202 "../src/sudoku-cell.vala"
					_tmp26_ = row_tmp;
#line 202 "../src/sudoku-cell.vala"
					row_tmp = _tmp26_ + 1;
#line 656 "sudoku-cell.c"
				}
#line 202 "../src/sudoku-cell.vala"
				_tmp25_ = FALSE;
#line 202 "../src/sudoku-cell.vala"
				_tmp27_ = sudoku_game_get_board (*game);
#line 202 "../src/sudoku-cell.vala"
				_tmp28_ = _tmp27_;
#line 202 "../src/sudoku-cell.vala"
				_tmp29_ = sudoku_board_get_block_rows (_tmp28_);
#line 202 "../src/sudoku-cell.vala"
				_tmp30_ = _tmp29_;
#line 202 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp30_)) {
#line 202 "../src/sudoku-cell.vala"
					break;
#line 672 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 204 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 678 "sudoku-cell.c"
					{
						gboolean _tmp31_ = FALSE;
#line 204 "../src/sudoku-cell.vala"
						_tmp31_ = TRUE;
#line 204 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 685 "sudoku-cell.c"
							SudokuBoard* _tmp33_;
							SudokuBoard* _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gint _tmp37_;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							gchar* _tmp39_;
							gchar* _tmp40_;
							GtkLabel* _tmp41_ = NULL;
							GtkLabel** _tmp42_;
							gint _tmp42__length1;
							GtkLabel* _tmp43_;
							GtkLabel** _tmp44_;
							gint _tmp44__length1;
							GtkLabel* _tmp45_;
#line 204 "../src/sudoku-cell.vala"
							if (!_tmp31_) {
#line 704 "sudoku-cell.c"
								gint _tmp32_;
#line 204 "../src/sudoku-cell.vala"
								_tmp32_ = col_tmp;
#line 204 "../src/sudoku-cell.vala"
								col_tmp = _tmp32_ + 1;
#line 710 "sudoku-cell.c"
							}
#line 204 "../src/sudoku-cell.vala"
							_tmp31_ = FALSE;
#line 204 "../src/sudoku-cell.vala"
							_tmp33_ = sudoku_game_get_board (*game);
#line 204 "../src/sudoku-cell.vala"
							_tmp34_ = _tmp33_;
#line 204 "../src/sudoku-cell.vala"
							_tmp35_ = sudoku_board_get_block_cols (_tmp34_);
#line 204 "../src/sudoku-cell.vala"
							_tmp36_ = _tmp35_;
#line 204 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp36_)) {
#line 204 "../src/sudoku-cell.vala"
								break;
#line 726 "sudoku-cell.c"
							}
#line 206 "../src/sudoku-cell.vala"
							_tmp37_ = num;
#line 206 "../src/sudoku-cell.vala"
							num = _tmp37_ + 1;
#line 208 "../src/sudoku-cell.vala"
							_tmp38_ = self->priv->earmark_labels;
#line 208 "../src/sudoku-cell.vala"
							_tmp38__length1 = self->priv->earmark_labels_length1;
#line 208 "../src/sudoku-cell.vala"
							_tmp39_ = g_strdup_printf ("%i", num);
#line 208 "../src/sudoku-cell.vala"
							_tmp40_ = _tmp39_;
#line 208 "../src/sudoku-cell.vala"
							_tmp41_ = (GtkLabel*) gtk_label_new (_tmp40_);
#line 208 "../src/sudoku-cell.vala"
							gtk_widget_set_visible ((GtkWidget*) _tmp41_, FALSE);
#line 208 "../src/sudoku-cell.vala"
							g_object_ref_sink (_tmp41_);
#line 208 "../src/sudoku-cell.vala"
							_g_object_unref0 (_tmp38_[num - 1]);
#line 208 "../src/sudoku-cell.vala"
							_tmp38_[num - 1] = _tmp41_;
#line 208 "../src/sudoku-cell.vala"
							_g_free0 (_tmp40_);
#line 211 "../src/sudoku-cell.vala"
							_tmp42_ = self->priv->earmark_labels;
#line 211 "../src/sudoku-cell.vala"
							_tmp42__length1 = self->priv->earmark_labels_length1;
#line 211 "../src/sudoku-cell.vala"
							_tmp43_ = _tmp42_[num - 1];
#line 211 "../src/sudoku-cell.vala"
							gtk_widget_set_parent ((GtkWidget*) _tmp43_, (GtkWidget*) self);
#line 212 "../src/sudoku-cell.vala"
							_tmp44_ = self->priv->earmark_labels;
#line 212 "../src/sudoku-cell.vala"
							_tmp44__length1 = self->priv->earmark_labels_length1;
#line 212 "../src/sudoku-cell.vala"
							_tmp45_ = _tmp44_[num - 1];
#line 212 "../src/sudoku-cell.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp45_, "earmark");
#line 768 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 216 "../src/sudoku-cell.vala"
	_tmp46_ = sudoku_cell_get_popover (self);
#line 216 "../src/sudoku-cell.vala"
	_tmp47_ = _tmp46_;
#line 216 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp47_, (GtkWidget*) self);
#line 217 "../src/sudoku-cell.vala"
	_tmp48_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 217 "../src/sudoku-cell.vala"
	popover_controller = _tmp48_;
#line 218 "../src/sudoku-cell.vala"
	_tmp49_ = popover_controller;
#line 218 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp49_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 219 "../src/sudoku-cell.vala"
	_tmp50_ = popover_controller;
#line 219 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp50_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 220 "../src/sudoku-cell.vala"
	_tmp52_ = sudoku_cell_get_popover (self);
#line 220 "../src/sudoku-cell.vala"
	_tmp53_ = _tmp52_;
#line 220 "../src/sudoku-cell.vala"
	_tmp51_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp53_) : NULL;
#line 220 "../src/sudoku-cell.vala"
	if (_tmp51_ != NULL) {
#line 801 "sudoku-cell.c"
		GtkEventControllerKey* _tmp54_;
		GtkEventController* _tmp55_;
#line 220 "../src/sudoku-cell.vala"
		_tmp54_ = popover_controller;
#line 220 "../src/sudoku-cell.vala"
		_tmp55_ = _g_object_ref0 ((GtkEventController*) _tmp54_);
#line 220 "../src/sudoku-cell.vala"
		gtk_widget_add_controller (_tmp51_, _tmp55_);
#line 810 "sudoku-cell.c"
	}
#line 221 "../src/sudoku-cell.vala"
	_tmp56_ = sudoku_cell_get_popover (self);
#line 221 "../src/sudoku-cell.vala"
	_tmp57_ = _tmp56_;
#line 221 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp57_, "closed", (GCallback) ___lambda10__gtk_popover_closed, self, 0);
#line 167 "../src/sudoku-cell.vala"
	_g_object_unref0 (popover_controller);
#line 167 "../src/sudoku-cell.vala"
	return self;
#line 822 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame** game)
{
#line 167 "../src/sudoku-cell.vala"
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game);
#line 832 "sudoku-cell.c"
}

void
sudoku_cell_update_value (SudokuCell* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 235 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 237 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 237 "../src/sudoku-cell.vala"
	if (!_tmp1_) {
#line 238 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 852 "sudoku-cell.c"
	}
#line 240 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_value (self);
#line 240 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 240 "../src/sudoku-cell.vala"
	if (_tmp3_ != 0) {
#line 860 "sudoku-cell.c"
		GtkLabel* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GtkLabel* _tmp9_;
#line 242 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->value_label;
#line 242 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_cell_get_value (self);
#line 242 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 242 "../src/sudoku-cell.vala"
		_tmp7_ = g_strdup_printf ("%i", _tmp6_);
#line 242 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 242 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp4_, _tmp8_);
#line 242 "../src/sudoku-cell.vala"
		_g_free0 (_tmp8_);
#line 243 "../src/sudoku-cell.vala"
		_tmp9_ = self->priv->value_label;
#line 243 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp9_, TRUE);
#line 885 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp10_;
#line 246 "../src/sudoku-cell.vala"
		_tmp10_ = self->priv->value_label;
#line 246 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 892 "sudoku-cell.c"
	}
#line 248 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 896 "sudoku-cell.c"
}

void
sudoku_cell_update_earmark (SudokuCell* self,
                            gint num,
                            gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 251 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 253 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 253 "../src/sudoku-cell.vala"
	if (!_tmp1_) {
#line 254 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 916 "sudoku-cell.c"
	}
#line 256 "../src/sudoku-cell.vala"
	sudoku_cell_check_earmark_warnings (self, num, enabled);
#line 257 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmark (self, num);
#line 922 "sudoku-cell.c"
}

static gboolean
sudoku_cell_key_pressed_cb (SudokuCell* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 259 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 263 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 263 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 939 "sudoku-cell.c"
	} else {
#line 263 "../src/sudoku-cell.vala"
		_tmp0_ = keyval == GDK_KEY_Control_R;
#line 943 "sudoku-cell.c"
	}
#line 263 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 264 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = TRUE;
#line 949 "sudoku-cell.c"
	}
#line 268 "../src/sudoku-cell.vala"
	result = GDK_EVENT_PROPAGATE;
#line 268 "../src/sudoku-cell.vala"
	return result;
#line 955 "sudoku-cell.c"
}

static void
sudoku_cell_key_released_cb (SudokuCell* self,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp6_ = FALSE;
	gint key = 0;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_ = FALSE;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_ = FALSE;
#line 271 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_is_fixed (self);
#line 275 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 275 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 275 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 984 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 275 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->game;
#line 275 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_game_get_paused (_tmp3_);
#line 275 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 275 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp5_;
#line 997 "sudoku-cell.c"
	}
#line 275 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 276 "../src/sudoku-cell.vala"
		return;
#line 1003 "sudoku-cell.c"
	}
#line 278 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 278 "../src/sudoku-cell.vala"
		_tmp6_ = TRUE;
#line 1009 "sudoku-cell.c"
	} else {
#line 278 "../src/sudoku-cell.vala"
		_tmp6_ = keyval == GDK_KEY_Control_R;
#line 1013 "sudoku-cell.c"
	}
#line 278 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 279 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = FALSE;
#line 1019 "sudoku-cell.c"
	}
#line 281 "../src/sudoku-cell.vala"
	key = sudoku_cell_get_key_number (self, keyval);
#line 282 "../src/sudoku-cell.vala"
	if (key >= 1) {
#line 282 "../src/sudoku-cell.vala"
		_tmp7_ = key <= 9;
#line 1027 "sudoku-cell.c"
	} else {
#line 282 "../src/sudoku-cell.vala"
		_tmp7_ = FALSE;
#line 1031 "sudoku-cell.c"
	}
#line 282 "../src/sudoku-cell.vala"
	if (_tmp7_) {
#line 1035 "sudoku-cell.c"
		NumberPicker* number_picker = NULL;
		GtkPopover* _tmp8_;
		GtkPopover* _tmp9_;
		GtkWidget* _tmp10_;
		NumberPicker* _tmp11_;
		gboolean ctrl_pressed = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		GtkPopover* _tmp15_;
		GtkPopover* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		gboolean want_earmark = FALSE;
		gboolean _tmp26_ = FALSE;
#line 285 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_cell_get_popover (self);
#line 285 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 285 "../src/sudoku-cell.vala"
		_tmp10_ = gtk_popover_get_child (_tmp9_);
#line 285 "../src/sudoku-cell.vala"
		_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_NUMBER_PICKER, NumberPicker));
#line 285 "../src/sudoku-cell.vala"
		number_picker = _tmp11_;
#line 286 "../src/sudoku-cell.vala"
		ctrl_pressed = (state & GDK_CONTROL_MASK) > 0;
#line 287 "../src/sudoku-cell.vala"
		_tmp15_ = sudoku_cell_get_popover (self);
#line 287 "../src/sudoku-cell.vala"
		_tmp16_ = _tmp15_;
#line 287 "../src/sudoku-cell.vala"
		_tmp17_ = gtk_widget_get_visible ((GtkWidget*) _tmp16_);
#line 287 "../src/sudoku-cell.vala"
		_tmp18_ = _tmp17_;
#line 287 "../src/sudoku-cell.vala"
		if (_tmp18_) {
#line 1073 "sudoku-cell.c"
			NumberPicker* _tmp19_;
#line 287 "../src/sudoku-cell.vala"
			_tmp19_ = number_picker;
#line 287 "../src/sudoku-cell.vala"
			_tmp14_ = _tmp19_ != NULL;
#line 1079 "sudoku-cell.c"
		} else {
#line 287 "../src/sudoku-cell.vala"
			_tmp14_ = FALSE;
#line 1083 "sudoku-cell.c"
		}
#line 287 "../src/sudoku-cell.vala"
		if (_tmp14_) {
#line 1087 "sudoku-cell.c"
			NumberPicker* _tmp20_;
			gboolean _tmp21_;
			gboolean _tmp22_;
#line 287 "../src/sudoku-cell.vala"
			_tmp20_ = number_picker;
#line 287 "../src/sudoku-cell.vala"
			_tmp21_ = number_picker_get_is_earmark_picker (_tmp20_);
#line 287 "../src/sudoku-cell.vala"
			_tmp22_ = _tmp21_;
#line 287 "../src/sudoku-cell.vala"
			_tmp13_ = _tmp22_;
#line 1099 "sudoku-cell.c"
		} else {
#line 287 "../src/sudoku-cell.vala"
			_tmp13_ = FALSE;
#line 1103 "sudoku-cell.c"
		}
#line 287 "../src/sudoku-cell.vala"
		if (_tmp13_) {
#line 287 "../src/sudoku-cell.vala"
			_tmp12_ = TRUE;
#line 1109 "sudoku-cell.c"
		} else {
			gboolean _tmp23_ = FALSE;
#line 288 "../src/sudoku-cell.vala"
			if (ctrl_pressed) {
#line 1114 "sudoku-cell.c"
				gint _tmp24_;
				gint _tmp25_;
#line 288 "../src/sudoku-cell.vala"
				_tmp24_ = sudoku_cell_get_value (self);
#line 288 "../src/sudoku-cell.vala"
				_tmp25_ = _tmp24_;
#line 288 "../src/sudoku-cell.vala"
				_tmp23_ = _tmp25_ == 0;
#line 1123 "sudoku-cell.c"
			} else {
#line 288 "../src/sudoku-cell.vala"
				_tmp23_ = FALSE;
#line 1127 "sudoku-cell.c"
			}
#line 288 "../src/sudoku-cell.vala"
			_tmp12_ = _tmp23_;
#line 1131 "sudoku-cell.c"
		}
#line 287 "../src/sudoku-cell.vala"
		want_earmark = _tmp12_;
#line 289 "../src/sudoku-cell.vala"
		if (want_earmark) {
#line 1137 "sudoku-cell.c"
			SudokuGame* _tmp27_;
			GameMode _tmp28_;
			GameMode _tmp29_;
#line 289 "../src/sudoku-cell.vala"
			_tmp27_ = self->priv->game;
#line 289 "../src/sudoku-cell.vala"
			_tmp28_ = sudoku_game_get_mode (_tmp27_);
#line 289 "../src/sudoku-cell.vala"
			_tmp29_ = _tmp28_;
#line 289 "../src/sudoku-cell.vala"
			_tmp26_ = _tmp29_ == GAME_MODE_PLAY;
#line 1149 "sudoku-cell.c"
		} else {
#line 289 "../src/sudoku-cell.vala"
			_tmp26_ = FALSE;
#line 1153 "sudoku-cell.c"
		}
#line 289 "../src/sudoku-cell.vala"
		if (_tmp26_) {
#line 1157 "sudoku-cell.c"
			gboolean new_state = FALSE;
			SudokuGame* _tmp30_;
			SudokuBoard* _tmp31_;
			SudokuBoard* _tmp32_;
			gboolean _tmp33_ = FALSE;
			NumberPicker* _tmp34_;
#line 291 "../src/sudoku-cell.vala"
			_tmp30_ = self->priv->game;
#line 291 "../src/sudoku-cell.vala"
			_tmp31_ = sudoku_game_get_board (_tmp30_);
#line 291 "../src/sudoku-cell.vala"
			_tmp32_ = _tmp31_;
#line 291 "../src/sudoku-cell.vala"
			new_state = !sudoku_board_is_earmark_enabled (_tmp32_, self->priv->row, self->priv->col, key);
#line 293 "../src/sudoku-cell.vala"
			_tmp34_ = number_picker;
#line 293 "../src/sudoku-cell.vala"
			if (_tmp34_ != NULL) {
#line 1176 "sudoku-cell.c"
				NumberPicker* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
#line 293 "../src/sudoku-cell.vala"
				_tmp35_ = number_picker;
#line 293 "../src/sudoku-cell.vala"
				_tmp36_ = number_picker_get_is_earmark_picker (_tmp35_);
#line 293 "../src/sudoku-cell.vala"
				_tmp37_ = _tmp36_;
#line 293 "../src/sudoku-cell.vala"
				_tmp33_ = _tmp37_;
#line 1188 "sudoku-cell.c"
			} else {
#line 293 "../src/sudoku-cell.vala"
				_tmp33_ = FALSE;
#line 1192 "sudoku-cell.c"
			}
#line 293 "../src/sudoku-cell.vala"
			if (_tmp33_) {
#line 1196 "sudoku-cell.c"
				NumberPicker* _tmp38_;
#line 295 "../src/sudoku-cell.vala"
				_tmp38_ = number_picker;
#line 295 "../src/sudoku-cell.vala"
				number_picker_set_earmark (_tmp38_, self->priv->row, self->priv->col, key - 1, new_state);
#line 1202 "sudoku-cell.c"
			} else {
#line 299 "../src/sudoku-cell.vala"
				if (new_state) {
#line 1206 "sudoku-cell.c"
					SudokuGame* _tmp39_;
#line 300 "../src/sudoku-cell.vala"
					_tmp39_ = self->priv->game;
#line 300 "../src/sudoku-cell.vala"
					sudoku_game_enable_earmark (_tmp39_, self->priv->row, self->priv->col, key);
#line 1212 "sudoku-cell.c"
				} else {
					SudokuGame* _tmp40_;
#line 302 "../src/sudoku-cell.vala"
					_tmp40_ = self->priv->game;
#line 302 "../src/sudoku-cell.vala"
					sudoku_game_disable_earmark (_tmp40_, self->priv->row, self->priv->col, key);
#line 1219 "sudoku-cell.c"
				}
			}
		} else {
#line 305 "../src/sudoku-cell.vala"
			if (!ctrl_pressed) {
#line 1225 "sudoku-cell.c"
				SudokuGame* _tmp41_;
				SudokuBoard* _tmp42_;
				SudokuBoard* _tmp43_;
#line 307 "../src/sudoku-cell.vala"
				sudoku_cell_set_value (self, key);
#line 308 "../src/sudoku-cell.vala"
				_tmp41_ = self->priv->game;
#line 308 "../src/sudoku-cell.vala"
				_tmp42_ = sudoku_game_get_board (_tmp41_);
#line 308 "../src/sudoku-cell.vala"
				_tmp43_ = _tmp42_;
#line 308 "../src/sudoku-cell.vala"
				sudoku_board_disable_all_earmarks (_tmp43_, self->priv->row, self->priv->col);
#line 1239 "sudoku-cell.c"
			}
		}
#line 310 "../src/sudoku-cell.vala"
		_g_object_unref0 (number_picker);
#line 310 "../src/sudoku-cell.vala"
		return;
#line 1246 "sudoku-cell.c"
	}
#line 313 "../src/sudoku-cell.vala"
	if (key == 0) {
#line 313 "../src/sudoku-cell.vala"
		_tmp45_ = TRUE;
#line 1252 "sudoku-cell.c"
	} else {
#line 314 "../src/sudoku-cell.vala"
		_tmp45_ = keyval == GDK_KEY_BackSpace;
#line 1256 "sudoku-cell.c"
	}
#line 313 "../src/sudoku-cell.vala"
	if (_tmp45_) {
#line 313 "../src/sudoku-cell.vala"
		_tmp44_ = TRUE;
#line 1262 "sudoku-cell.c"
	} else {
#line 315 "../src/sudoku-cell.vala"
		_tmp44_ = keyval == GDK_KEY_Delete;
#line 1266 "sudoku-cell.c"
	}
#line 313 "../src/sudoku-cell.vala"
	if (_tmp44_) {
#line 1270 "sudoku-cell.c"
		SudokuGame* _tmp46_;
		SudokuBoard* _tmp47_;
		SudokuBoard* _tmp48_;
#line 317 "../src/sudoku-cell.vala"
		_tmp46_ = self->priv->game;
#line 317 "../src/sudoku-cell.vala"
		_tmp47_ = sudoku_game_get_board (_tmp46_);
#line 317 "../src/sudoku-cell.vala"
		_tmp48_ = _tmp47_;
#line 317 "../src/sudoku-cell.vala"
		if (sudoku_board_has_earmarks (_tmp48_, self->priv->row, self->priv->col)) {
#line 1282 "sudoku-cell.c"
			SudokuGame* _tmp49_;
#line 318 "../src/sudoku-cell.vala"
			_tmp49_ = self->priv->game;
#line 318 "../src/sudoku-cell.vala"
			sudoku_game_disable_all_earmarks (_tmp49_, self->priv->row, self->priv->col);
#line 1288 "sudoku-cell.c"
		}
#line 319 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, 0);
#line 320 "../src/sudoku-cell.vala"
		return;
#line 1294 "sudoku-cell.c"
	}
#line 323 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_space) {
#line 323 "../src/sudoku-cell.vala"
		_tmp51_ = TRUE;
#line 1300 "sudoku-cell.c"
	} else {
#line 324 "../src/sudoku-cell.vala"
		_tmp51_ = keyval == GDK_KEY_Return;
#line 1304 "sudoku-cell.c"
	}
#line 323 "../src/sudoku-cell.vala"
	if (_tmp51_) {
#line 323 "../src/sudoku-cell.vala"
		_tmp50_ = TRUE;
#line 1310 "sudoku-cell.c"
	} else {
#line 325 "../src/sudoku-cell.vala"
		_tmp50_ = keyval == GDK_KEY_KP_Enter;
#line 1314 "sudoku-cell.c"
	}
#line 323 "../src/sudoku-cell.vala"
	if (_tmp50_) {
#line 327 "../src/sudoku-cell.vala"
		sudoku_cell_show_number_picker (self);
#line 328 "../src/sudoku-cell.vala"
		return;
#line 1322 "sudoku-cell.c"
	}
#line 331 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Escape) {
#line 1326 "sudoku-cell.c"
		GtkPopover* _tmp52_;
		GtkPopover* _tmp53_;
		gboolean _tmp54_;
		gboolean _tmp55_;
#line 333 "../src/sudoku-cell.vala"
		_tmp52_ = sudoku_cell_get_popover (self);
#line 333 "../src/sudoku-cell.vala"
		_tmp53_ = _tmp52_;
#line 333 "../src/sudoku-cell.vala"
		_tmp54_ = gtk_widget_get_visible ((GtkWidget*) _tmp53_);
#line 333 "../src/sudoku-cell.vala"
		_tmp55_ = _tmp54_;
#line 333 "../src/sudoku-cell.vala"
		if (_tmp55_) {
#line 1341 "sudoku-cell.c"
			GtkPopover* _tmp56_;
			GtkPopover* _tmp57_;
#line 334 "../src/sudoku-cell.vala"
			_tmp56_ = sudoku_cell_get_popover (self);
#line 334 "../src/sudoku-cell.vala"
			_tmp57_ = _tmp56_;
#line 334 "../src/sudoku-cell.vala"
			gtk_popover_popdown (_tmp57_);
#line 1350 "sudoku-cell.c"
		}
#line 335 "../src/sudoku-cell.vala"
		return;
#line 1354 "sudoku-cell.c"
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* gesture,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SudokuGame* _tmp8_;
	GameMode _tmp9_;
	GameMode _tmp10_;
#line 339 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 343 "../src/sudoku-cell.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 345 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 345 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 345 "../src/sudoku-cell.vala"
	if (!_tmp1_) {
#line 346 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 1386 "sudoku-cell.c"
	}
#line 348 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_cell_get_is_fixed (self);
#line 348 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 348 "../src/sudoku-cell.vala"
	if (_tmp4_) {
#line 348 "../src/sudoku-cell.vala"
		_tmp2_ = TRUE;
#line 1396 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 348 "../src/sudoku-cell.vala"
		_tmp5_ = self->priv->game;
#line 348 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_game_get_paused (_tmp5_);
#line 348 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 348 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp7_;
#line 1409 "sudoku-cell.c"
	}
#line 348 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 349 "../src/sudoku-cell.vala"
		return;
#line 1415 "sudoku-cell.c"
	}
#line 351 "../src/sudoku-cell.vala"
	_tmp8_ = self->priv->game;
#line 351 "../src/sudoku-cell.vala"
	_tmp9_ = sudoku_game_get_mode (_tmp8_);
#line 351 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_;
#line 351 "../src/sudoku-cell.vala"
	if (_tmp10_ == GAME_MODE_CREATE) {
#line 352 "../src/sudoku-cell.vala"
		sudoku_cell_show_number_picker (self);
#line 1427 "sudoku-cell.c"
	} else {
		gint _tmp11_;
		gint _tmp12_;
#line 353 "../src/sudoku-cell.vala"
		_tmp11_ = sudoku_cell_get_value (self);
#line 353 "../src/sudoku-cell.vala"
		_tmp12_ = _tmp11_;
#line 353 "../src/sudoku-cell.vala"
		if (_tmp12_ == 0) {
#line 354 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1439 "sudoku-cell.c"
		}
	}
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* gesture,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 357 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 362 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 363 "../src/sudoku-cell.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 1465 "sudoku-cell.c"
	} else {
#line 362 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1469 "sudoku-cell.c"
	}
#line 362 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 364 "../src/sudoku-cell.vala"
		return;
#line 1475 "sudoku-cell.c"
	}
#line 366 "../src/sudoku-cell.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 368 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
#line 368 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 368 "../src/sudoku-cell.vala"
	if (!_tmp2_) {
#line 369 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 1487 "sudoku-cell.c"
	}
#line 371 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_cell_get_is_fixed (self);
#line 371 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 371 "../src/sudoku-cell.vala"
	if (_tmp5_) {
#line 371 "../src/sudoku-cell.vala"
		_tmp3_ = TRUE;
#line 1497 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 371 "../src/sudoku-cell.vala"
		_tmp6_ = self->priv->game;
#line 371 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_game_get_paused (_tmp6_);
#line 371 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 371 "../src/sudoku-cell.vala"
		_tmp3_ = _tmp8_;
#line 1510 "sudoku-cell.c"
	}
#line 371 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 372 "../src/sudoku-cell.vala"
		return;
#line 1516 "sudoku-cell.c"
	}
#line 374 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1520 "sudoku-cell.c"
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		SudokuGame* _tmp11_;
		GameMode _tmp12_;
		GameMode _tmp13_;
#line 376 "../src/sudoku-cell.vala"
		_tmp11_ = self->priv->game;
#line 376 "../src/sudoku-cell.vala"
		_tmp12_ = sudoku_game_get_mode (_tmp11_);
#line 376 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_;
#line 376 "../src/sudoku-cell.vala"
		if (_tmp13_ == GAME_MODE_PLAY) {
#line 1534 "sudoku-cell.c"
			GdkEventSequence* _tmp14_;
			GdkEvent* _tmp15_;
#line 377 "../src/sudoku-cell.vala"
			_tmp14_ = gtk_gesture_get_last_updated_sequence ((GtkGesture*) gesture);
#line 377 "../src/sudoku-cell.vala"
			_tmp15_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp14_);
#line 377 "../src/sudoku-cell.vala"
			_tmp10_ = (gdk_event_get_modifier_state (_tmp15_) & GDK_CONTROL_MASK) > 0;
#line 1543 "sudoku-cell.c"
		} else {
#line 376 "../src/sudoku-cell.vala"
			_tmp10_ = FALSE;
#line 1547 "sudoku-cell.c"
		}
#line 376 "../src/sudoku-cell.vala"
		if (_tmp10_) {
#line 1551 "sudoku-cell.c"
			gint _tmp16_;
			gint _tmp17_;
#line 378 "../src/sudoku-cell.vala"
			_tmp16_ = sudoku_cell_get_value (self);
#line 378 "../src/sudoku-cell.vala"
			_tmp17_ = _tmp16_;
#line 378 "../src/sudoku-cell.vala"
			_tmp9_ = _tmp17_ == 0;
#line 1560 "sudoku-cell.c"
		} else {
#line 376 "../src/sudoku-cell.vala"
			_tmp9_ = FALSE;
#line 1564 "sudoku-cell.c"
		}
#line 376 "../src/sudoku-cell.vala"
		if (_tmp9_) {
#line 380 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1570 "sudoku-cell.c"
		} else {
#line 383 "../src/sudoku-cell.vala"
			sudoku_cell_show_number_picker (self);
#line 1574 "sudoku-cell.c"
		}
	} else {
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
#line 385 "../src/sudoku-cell.vala"
		if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_SECONDARY)) {
#line 1581 "sudoku-cell.c"
			SudokuGame* _tmp20_;
			GameMode _tmp21_;
			GameMode _tmp22_;
#line 386 "../src/sudoku-cell.vala"
			_tmp20_ = self->priv->game;
#line 386 "../src/sudoku-cell.vala"
			_tmp21_ = sudoku_game_get_mode (_tmp20_);
#line 386 "../src/sudoku-cell.vala"
			_tmp22_ = _tmp21_;
#line 386 "../src/sudoku-cell.vala"
			_tmp19_ = _tmp22_ == GAME_MODE_PLAY;
#line 1593 "sudoku-cell.c"
		} else {
#line 385 "../src/sudoku-cell.vala"
			_tmp19_ = FALSE;
#line 1597 "sudoku-cell.c"
		}
#line 385 "../src/sudoku-cell.vala"
		if (_tmp19_) {
#line 1601 "sudoku-cell.c"
			gint _tmp23_;
			gint _tmp24_;
#line 387 "../src/sudoku-cell.vala"
			_tmp23_ = sudoku_cell_get_value (self);
#line 387 "../src/sudoku-cell.vala"
			_tmp24_ = _tmp23_;
#line 387 "../src/sudoku-cell.vala"
			_tmp18_ = _tmp24_ == 0;
#line 1610 "sudoku-cell.c"
		} else {
#line 385 "../src/sudoku-cell.vala"
			_tmp18_ = FALSE;
#line 1614 "sudoku-cell.c"
		}
#line 385 "../src/sudoku-cell.vala"
		if (_tmp18_) {
#line 389 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1620 "sudoku-cell.c"
		}
	}
}

static gint
sudoku_cell_get_key_number (SudokuCell* self,
                            guint keyval)
{
	gint result;
#line 393 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 395 "../src/sudoku-cell.vala"
	switch (keyval) {
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_0:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_0:
#line 1638 "sudoku-cell.c"
		{
#line 399 "../src/sudoku-cell.vala"
			result = 0;
#line 399 "../src/sudoku-cell.vala"
			return result;
#line 1644 "sudoku-cell.c"
		}
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_1:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_1:
#line 1650 "sudoku-cell.c"
		{
#line 402 "../src/sudoku-cell.vala"
			result = 1;
#line 402 "../src/sudoku-cell.vala"
			return result;
#line 1656 "sudoku-cell.c"
		}
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_2:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_2:
#line 1662 "sudoku-cell.c"
		{
#line 405 "../src/sudoku-cell.vala"
			result = 2;
#line 405 "../src/sudoku-cell.vala"
			return result;
#line 1668 "sudoku-cell.c"
		}
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_3:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_3:
#line 1674 "sudoku-cell.c"
		{
#line 408 "../src/sudoku-cell.vala"
			result = 3;
#line 408 "../src/sudoku-cell.vala"
			return result;
#line 1680 "sudoku-cell.c"
		}
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_4:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_4:
#line 1686 "sudoku-cell.c"
		{
#line 411 "../src/sudoku-cell.vala"
			result = 4;
#line 411 "../src/sudoku-cell.vala"
			return result;
#line 1692 "sudoku-cell.c"
		}
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_5:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_5:
#line 1698 "sudoku-cell.c"
		{
#line 414 "../src/sudoku-cell.vala"
			result = 5;
#line 414 "../src/sudoku-cell.vala"
			return result;
#line 1704 "sudoku-cell.c"
		}
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_6:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_6:
#line 1710 "sudoku-cell.c"
		{
#line 417 "../src/sudoku-cell.vala"
			result = 6;
#line 417 "../src/sudoku-cell.vala"
			return result;
#line 1716 "sudoku-cell.c"
		}
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_7:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_7:
#line 1722 "sudoku-cell.c"
		{
#line 420 "../src/sudoku-cell.vala"
			result = 7;
#line 420 "../src/sudoku-cell.vala"
			return result;
#line 1728 "sudoku-cell.c"
		}
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_8:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_8:
#line 1734 "sudoku-cell.c"
		{
#line 423 "../src/sudoku-cell.vala"
			result = 8;
#line 423 "../src/sudoku-cell.vala"
			return result;
#line 1740 "sudoku-cell.c"
		}
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_9:
#line 395 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_9:
#line 1746 "sudoku-cell.c"
		{
#line 426 "../src/sudoku-cell.vala"
			result = 9;
#line 426 "../src/sudoku-cell.vala"
			return result;
#line 1752 "sudoku-cell.c"
		}
		default:
		{
#line 428 "../src/sudoku-cell.vala"
			result = -1;
#line 428 "../src/sudoku-cell.vala"
			return result;
#line 1760 "sudoku-cell.c"
		}
	}
}

void
sudoku_cell_initialize_earmarks (SudokuCell* self,
                                 gboolean show_possibilities)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp6_ = FALSE;
#line 432 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 434 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 434 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 434 "../src/sudoku-cell.vala"
	if (_tmp2_ != 0) {
#line 434 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 1783 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 434 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->game;
#line 434 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 434 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 434 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp5_ == GAME_MODE_CREATE;
#line 1796 "sudoku-cell.c"
	}
#line 434 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 435 "../src/sudoku-cell.vala"
		return;
#line 1802 "sudoku-cell.c"
	}
#line 437 "../src/sudoku-cell.vala"
	if (show_possibilities) {
#line 1806 "sudoku-cell.c"
		SudokuGame* _tmp7_;
		SudokuBoard* _tmp8_;
		SudokuBoard* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 437 "../src/sudoku-cell.vala"
		_tmp7_ = self->priv->game;
#line 437 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_game_get_board (_tmp7_);
#line 437 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 437 "../src/sudoku-cell.vala"
		_tmp10_ = sudoku_board_get_previous_played_time (_tmp9_);
#line 437 "../src/sudoku-cell.vala"
		_tmp11_ = _tmp10_;
#line 437 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp11_ == 0.0;
#line 1824 "sudoku-cell.c"
	} else {
#line 437 "../src/sudoku-cell.vala"
		_tmp6_ = FALSE;
#line 1828 "sudoku-cell.c"
	}
#line 437 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 1832 "sudoku-cell.c"
		gboolean* marks = NULL;
		SudokuGame* _tmp12_;
		SudokuBoard* _tmp13_;
		SudokuBoard* _tmp14_;
		gint _tmp15_ = 0;
		gboolean* _tmp16_;
		gint marks_length1;
		gint _marks_size_;
#line 439 "../src/sudoku-cell.vala"
		_tmp12_ = self->priv->game;
#line 439 "../src/sudoku-cell.vala"
		_tmp13_ = sudoku_game_get_board (_tmp12_);
#line 439 "../src/sudoku-cell.vala"
		_tmp14_ = _tmp13_;
#line 439 "../src/sudoku-cell.vala"
		_tmp16_ = sudoku_board_get_possibilities_as_bool_array (_tmp14_, self->priv->row, self->priv->col, &_tmp15_);
#line 439 "../src/sudoku-cell.vala"
		marks = _tmp16_;
#line 439 "../src/sudoku-cell.vala"
		marks_length1 = _tmp15_;
#line 439 "../src/sudoku-cell.vala"
		_marks_size_ = marks_length1;
#line 1855 "sudoku-cell.c"
		{
			gint num = 0;
#line 440 "../src/sudoku-cell.vala"
			num = 1;
#line 1860 "sudoku-cell.c"
			{
				gboolean _tmp17_ = FALSE;
#line 440 "../src/sudoku-cell.vala"
				_tmp17_ = TRUE;
#line 440 "../src/sudoku-cell.vala"
				while (TRUE) {
#line 1867 "sudoku-cell.c"
					gboolean* _tmp19_;
					gint _tmp19__length1;
					gboolean _tmp20_;
#line 440 "../src/sudoku-cell.vala"
					if (!_tmp17_) {
#line 1873 "sudoku-cell.c"
						gint _tmp18_;
#line 440 "../src/sudoku-cell.vala"
						_tmp18_ = num;
#line 440 "../src/sudoku-cell.vala"
						num = _tmp18_ + 1;
#line 1879 "sudoku-cell.c"
					}
#line 440 "../src/sudoku-cell.vala"
					_tmp17_ = FALSE;
#line 440 "../src/sudoku-cell.vala"
					if (!(num <= 9)) {
#line 440 "../src/sudoku-cell.vala"
						break;
#line 1887 "sudoku-cell.c"
					}
#line 442 "../src/sudoku-cell.vala"
					_tmp19_ = marks;
#line 442 "../src/sudoku-cell.vala"
					_tmp19__length1 = marks_length1;
#line 442 "../src/sudoku-cell.vala"
					_tmp20_ = _tmp19_[num - 1];
#line 442 "../src/sudoku-cell.vala"
					if (_tmp20_) {
#line 1897 "sudoku-cell.c"
						SudokuGame* _tmp21_;
						SudokuBoard* _tmp22_;
						SudokuBoard* _tmp23_;
#line 443 "../src/sudoku-cell.vala"
						_tmp21_ = self->priv->game;
#line 443 "../src/sudoku-cell.vala"
						_tmp22_ = sudoku_game_get_board (_tmp21_);
#line 443 "../src/sudoku-cell.vala"
						_tmp23_ = _tmp22_;
#line 443 "../src/sudoku-cell.vala"
						sudoku_board_enable_earmark (_tmp23_, self->priv->row, self->priv->col, num);
#line 1909 "sudoku-cell.c"
					}
				}
			}
		}
#line 437 "../src/sudoku-cell.vala"
		marks = (g_free (marks), NULL);
#line 1916 "sudoku-cell.c"
	}
#line 447 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 1920 "sudoku-cell.c"
}

static void
sudoku_cell_get_visible_earmarks (SudokuCell* self)
{
#line 450 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 1928 "sudoku-cell.c"
	{
		gint num = 0;
#line 452 "../src/sudoku-cell.vala"
		num = 1;
#line 1933 "sudoku-cell.c"
		{
			gboolean _tmp0_ = FALSE;
#line 452 "../src/sudoku-cell.vala"
			_tmp0_ = TRUE;
#line 452 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 452 "../src/sudoku-cell.vala"
				if (!_tmp0_) {
#line 1942 "sudoku-cell.c"
					gint _tmp1_;
#line 452 "../src/sudoku-cell.vala"
					_tmp1_ = num;
#line 452 "../src/sudoku-cell.vala"
					num = _tmp1_ + 1;
#line 1948 "sudoku-cell.c"
				}
#line 452 "../src/sudoku-cell.vala"
				_tmp0_ = FALSE;
#line 452 "../src/sudoku-cell.vala"
				if (!(num <= 9)) {
#line 452 "../src/sudoku-cell.vala"
					break;
#line 1956 "sudoku-cell.c"
				}
#line 453 "../src/sudoku-cell.vala"
				sudoku_cell_get_visible_earmark (self, num);
#line 1960 "sudoku-cell.c"
			}
		}
	}
}

static void
sudoku_cell_get_visible_earmark (SudokuCell* self,
                                 gint num)
{
	gint _tmp0_;
	gint _tmp1_;
#line 456 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 458 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 458 "../src/sudoku-cell.vala"
	if (_tmp1_ != 0) {
#line 1980 "sudoku-cell.c"
		GtkLabel** _tmp2_;
		gint _tmp2__length1;
		GtkLabel* _tmp3_;
#line 459 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->earmark_labels;
#line 459 "../src/sudoku-cell.vala"
		_tmp2__length1 = self->priv->earmark_labels_length1;
#line 459 "../src/sudoku-cell.vala"
		_tmp3_ = _tmp2_[num - 1];
#line 459 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 1992 "sudoku-cell.c"
	} else {
		GtkLabel** _tmp4_;
		gint _tmp4__length1;
		GtkLabel* _tmp5_;
		SudokuGame* _tmp6_;
		SudokuBoard* _tmp7_;
		SudokuBoard* _tmp8_;
#line 461 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->earmark_labels;
#line 461 "../src/sudoku-cell.vala"
		_tmp4__length1 = self->priv->earmark_labels_length1;
#line 461 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_[num - 1];
#line 461 "../src/sudoku-cell.vala"
		_tmp6_ = self->priv->game;
#line 461 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_game_get_board (_tmp6_);
#line 461 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 461 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, sudoku_board_is_earmark_enabled (_tmp8_, self->priv->row, self->priv->col, num));
#line 2014 "sudoku-cell.c"
	}
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 464 "../src/sudoku-cell.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 464 "../src/sudoku-cell.vala"
	return _data10_;
#line 2025 "sudoku-cell.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 464 "../src/sudoku-cell.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2035 "sudoku-cell.c"
		SudokuCell* self;
#line 464 "../src/sudoku-cell.vala"
		self = _data10_->self;
#line 464 "../src/sudoku-cell.vala"
		_g_object_unref0 (_data10_->earmark_picker);
#line 464 "../src/sudoku-cell.vala"
		_g_object_unref0 (self);
#line 464 "../src/sudoku-cell.vala"
		g_slice_free (Block10Data, _data10_);
#line 2045 "sudoku-cell.c"
	}
}

static void
__lambda9_ (Block10Data* _data10_,
            gint number,
            gboolean state)
{
	SudokuCell* self;
	NumberPicker* _tmp9_;
	SudokuGame* _tmp10_;
	SudokuBoard* _tmp11_;
	SudokuBoard* _tmp12_;
#line 481 "../src/sudoku-cell.vala"
	self = _data10_->self;
#line 482 "../src/sudoku-cell.vala"
	if (state) {
#line 2063 "sudoku-cell.c"
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
		SudokuBoard* _tmp2_;
#line 484 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->game;
#line 484 "../src/sudoku-cell.vala"
		_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 484 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp1_;
#line 484 "../src/sudoku-cell.vala"
		if (!sudoku_board_is_earmark_enabled (_tmp2_, self->priv->row, self->priv->col, number)) {
#line 2075 "sudoku-cell.c"
			SudokuGame* _tmp3_;
#line 485 "../src/sudoku-cell.vala"
			_tmp3_ = self->priv->game;
#line 485 "../src/sudoku-cell.vala"
			sudoku_game_enable_earmark (_tmp3_, self->priv->row, self->priv->col, number);
#line 2081 "sudoku-cell.c"
		}
	} else {
#line 489 "../src/sudoku-cell.vala"
		if (number == 0) {
#line 2086 "sudoku-cell.c"
			SudokuGame* _tmp4_;
#line 490 "../src/sudoku-cell.vala"
			_tmp4_ = self->priv->game;
#line 490 "../src/sudoku-cell.vala"
			sudoku_game_disable_all_earmarks (_tmp4_, self->priv->row, self->priv->col);
#line 2092 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp5_;
			SudokuBoard* _tmp6_;
			SudokuBoard* _tmp7_;
#line 492 "../src/sudoku-cell.vala"
			_tmp5_ = self->priv->game;
#line 492 "../src/sudoku-cell.vala"
			_tmp6_ = sudoku_game_get_board (_tmp5_);
#line 492 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp6_;
#line 492 "../src/sudoku-cell.vala"
			if (sudoku_board_is_earmark_enabled (_tmp7_, self->priv->row, self->priv->col, number)) {
#line 2105 "sudoku-cell.c"
				SudokuGame* _tmp8_;
#line 493 "../src/sudoku-cell.vala"
				_tmp8_ = self->priv->game;
#line 493 "../src/sudoku-cell.vala"
				sudoku_game_disable_earmark (_tmp8_, self->priv->row, self->priv->col, number);
#line 2111 "sudoku-cell.c"
			}
		}
	}
#line 496 "../src/sudoku-cell.vala"
	_tmp9_ = _data10_->earmark_picker;
#line 496 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->game;
#line 496 "../src/sudoku-cell.vala"
	_tmp11_ = sudoku_game_get_board (_tmp10_);
#line 496 "../src/sudoku-cell.vala"
	_tmp12_ = _tmp11_;
#line 496 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_enabled (_tmp9_, sudoku_board_has_earmarks (_tmp12_, self->priv->row, self->priv->col));
#line 2125 "sudoku-cell.c"
}

static void
___lambda9__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
#line 481 "../src/sudoku-cell.vala"
	__lambda9_ (self, number, active);
#line 2136 "sudoku-cell.c"
}

static void
sudoku_cell_show_earmark_picker (SudokuCell* self)
{
	gint _tmp0_;
	gint _tmp1_;
	Block10Data* _data10_;
	GtkPopover* _tmp2_;
	GtkPopover* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	SudokuGame* _tmp12_;
	NumberPicker* _tmp13_;
	NumberPicker* _tmp14_;
	SudokuGame* _tmp15_;
	SudokuBoard* _tmp16_;
	SudokuBoard* _tmp17_;
	NumberPicker* _tmp19_;
	NumberPicker* _tmp20_;
	GtkPopover* _tmp21_;
	GtkPopover* _tmp22_;
	NumberPicker* _tmp23_;
	GtkPopover* _tmp24_;
	GtkPopover* _tmp25_;
#line 464 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 464 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 464 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 464 "../src/sudoku-cell.vala"
	_vala_return_if_fail (_tmp1_ == 0, "this.value == 0");
#line 464 "../src/sudoku-cell.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 464 "../src/sudoku-cell.vala"
	_data10_->_ref_count_ = 1;
#line 464 "../src/sudoku-cell.vala"
	_data10_->self = g_object_ref (self);
#line 467 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_popover (self);
#line 467 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 467 "../src/sudoku-cell.vala"
	_tmp4_ = gtk_widget_get_visible ((GtkWidget*) _tmp3_);
#line 467 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 467 "../src/sudoku-cell.vala"
	if (_tmp5_) {
#line 2186 "sudoku-cell.c"
		GtkPopover* _tmp6_;
		GtkPopover* _tmp7_;
		GtkWidget* _tmp8_;
		GtkWidget* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 469 "../src/sudoku-cell.vala"
		sudoku_cell_dismiss_popover (self);
#line 470 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_cell_get_popover (self);
#line 470 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 470 "../src/sudoku-cell.vala"
		_tmp8_ = gtk_popover_get_child (_tmp7_);
#line 470 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 470 "../src/sudoku-cell.vala"
		_tmp10_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_NUMBER_PICKER, NumberPicker));
#line 470 "../src/sudoku-cell.vala"
		_tmp11_ = _tmp10_;
#line 470 "../src/sudoku-cell.vala"
		if (_tmp11_) {
#line 471 "../src/sudoku-cell.vala"
			block10_data_unref (_data10_);
#line 471 "../src/sudoku-cell.vala"
			_data10_ = NULL;
#line 471 "../src/sudoku-cell.vala"
			return;
#line 2215 "sudoku-cell.c"
		}
	}
#line 474 "../src/sudoku-cell.vala"
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
#line 476 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->game;
#line 476 "../src/sudoku-cell.vala"
	_tmp13_ = number_picker_new (_tmp12_, TRUE);
#line 476 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp13_);
#line 476 "../src/sudoku-cell.vala"
	_data10_->earmark_picker = _tmp13_;
#line 477 "../src/sudoku-cell.vala"
	_tmp14_ = _data10_->earmark_picker;
#line 477 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp14_, TRUE);
#line 478 "../src/sudoku-cell.vala"
	_tmp15_ = self->priv->game;
#line 478 "../src/sudoku-cell.vala"
	_tmp16_ = sudoku_game_get_board (_tmp15_);
#line 478 "../src/sudoku-cell.vala"
	_tmp17_ = _tmp16_;
#line 478 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp17_, self->priv->row, self->priv->col)) {
#line 2240 "sudoku-cell.c"
		NumberPicker* _tmp18_;
#line 479 "../src/sudoku-cell.vala"
		_tmp18_ = _data10_->earmark_picker;
#line 479 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp18_, FALSE);
#line 2246 "sudoku-cell.c"
	}
#line 481 "../src/sudoku-cell.vala"
	_tmp19_ = _data10_->earmark_picker;
#line 481 "../src/sudoku-cell.vala"
	g_signal_connect_data (_tmp19_, "earmark-state-changed", (GCallback) ___lambda9__number_picker_earmark_state_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 498 "../src/sudoku-cell.vala"
	_tmp20_ = _data10_->earmark_picker;
#line 498 "../src/sudoku-cell.vala"
	number_picker_set_earmarks (_tmp20_, self->priv->row, self->priv->col);
#line 499 "../src/sudoku-cell.vala"
	_tmp21_ = sudoku_cell_get_popover (self);
#line 499 "../src/sudoku-cell.vala"
	_tmp22_ = _tmp21_;
#line 499 "../src/sudoku-cell.vala"
	_tmp23_ = _data10_->earmark_picker;
#line 499 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp22_, (GtkWidget*) _tmp23_);
#line 501 "../src/sudoku-cell.vala"
	_tmp24_ = sudoku_cell_get_popover (self);
#line 501 "../src/sudoku-cell.vala"
	_tmp25_ = _tmp24_;
#line 501 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp25_);
#line 464 "../src/sudoku-cell.vala"
	block10_data_unref (_data10_);
#line 464 "../src/sudoku-cell.vala"
	_data10_ = NULL;
#line 2274 "sudoku-cell.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 504 "../src/sudoku-cell.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 504 "../src/sudoku-cell.vala"
	return _data11_;
#line 2284 "sudoku-cell.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 504 "../src/sudoku-cell.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 2294 "sudoku-cell.c"
		SudokuCell* self;
#line 504 "../src/sudoku-cell.vala"
		self = _data11_->self;
#line 504 "../src/sudoku-cell.vala"
		_g_object_unref0 (_data11_->number_picker);
#line 504 "../src/sudoku-cell.vala"
		_g_object_unref0 (self);
#line 504 "../src/sudoku-cell.vala"
		g_slice_free (Block11Data, _data11_);
#line 2304 "sudoku-cell.c"
	}
}

static void
__lambda8_ (Block11Data* _data11_,
            NumberPicker* o,
            gint number)
{
	SudokuCell* self;
#line 516 "../src/sudoku-cell.vala"
	self = _data11_->self;
#line 516 "../src/sudoku-cell.vala"
	g_return_if_fail (o != NULL);
#line 517 "../src/sudoku-cell.vala"
	if (number > 0) {
#line 2320 "sudoku-cell.c"
		GtkPopover* _tmp0_;
		GtkPopover* _tmp1_;
#line 518 "../src/sudoku-cell.vala"
		_tmp0_ = sudoku_cell_get_popover (self);
#line 518 "../src/sudoku-cell.vala"
		_tmp1_ = _tmp0_;
#line 518 "../src/sudoku-cell.vala"
		gtk_popover_popdown (_tmp1_);
#line 2329 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		SudokuBoard* _tmp4_;
		NumberPicker* _tmp5_;
#line 521 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->game;
#line 521 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 521 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 521 "../src/sudoku-cell.vala"
		sudoku_board_disable_all_earmarks (_tmp4_, self->priv->row, self->priv->col);
#line 522 "../src/sudoku-cell.vala"
		_tmp5_ = _data11_->number_picker;
#line 522 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_visibility (_tmp5_, FALSE);
#line 2347 "sudoku-cell.c"
	}
#line 524 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, number);
#line 2351 "sudoku-cell.c"
}

static void
___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
#line 516 "../src/sudoku-cell.vala"
	__lambda8_ (self, _sender, number);
#line 2361 "sudoku-cell.c"
}

static void
sudoku_cell_show_number_picker (SudokuCell* self)
{
	Block11Data* _data11_;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuGame* _tmp10_;
	NumberPicker* _tmp11_;
	NumberPicker* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gint _tmp14_;
	gint _tmp15_;
	NumberPicker* _tmp19_;
	GtkPopover* _tmp20_;
	GtkPopover* _tmp21_;
	NumberPicker* _tmp22_;
	GtkPopover* _tmp23_;
	GtkPopover* _tmp24_;
#line 504 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 504 "../src/sudoku-cell.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 504 "../src/sudoku-cell.vala"
	_data11_->_ref_count_ = 1;
#line 504 "../src/sudoku-cell.vala"
	_data11_->self = g_object_ref (self);
#line 506 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 506 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 506 "../src/sudoku-cell.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 506 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 506 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 2402 "sudoku-cell.c"
		GtkPopover* _tmp4_;
		GtkPopover* _tmp5_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 508 "../src/sudoku-cell.vala"
		sudoku_cell_dismiss_popover (self);
#line 509 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_popover (self);
#line 509 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 509 "../src/sudoku-cell.vala"
		_tmp6_ = gtk_popover_get_child (_tmp5_);
#line 509 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 509 "../src/sudoku-cell.vala"
		_tmp8_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_NUMBER_PICKER, NumberPicker));
#line 509 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 509 "../src/sudoku-cell.vala"
		if (!_tmp9_) {
#line 510 "../src/sudoku-cell.vala"
			block11_data_unref (_data11_);
#line 510 "../src/sudoku-cell.vala"
			_data11_ = NULL;
#line 510 "../src/sudoku-cell.vala"
			return;
#line 2431 "sudoku-cell.c"
		}
	}
#line 513 "../src/sudoku-cell.vala"
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
#line 515 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->game;
#line 515 "../src/sudoku-cell.vala"
	_tmp11_ = number_picker_new (_tmp10_, FALSE);
#line 515 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp11_);
#line 515 "../src/sudoku-cell.vala"
	_data11_->number_picker = _tmp11_;
#line 516 "../src/sudoku-cell.vala"
	_tmp12_ = _data11_->number_picker;
#line 516 "../src/sudoku-cell.vala"
	g_signal_connect_data (_tmp12_, "number-picked", (GCallback) ___lambda8__number_picker_number_picked, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 526 "../src/sudoku-cell.vala"
	_tmp14_ = sudoku_cell_get_value (self);
#line 526 "../src/sudoku-cell.vala"
	_tmp15_ = _tmp14_;
#line 526 "../src/sudoku-cell.vala"
	if (_tmp15_ > 0) {
#line 526 "../src/sudoku-cell.vala"
		_tmp13_ = TRUE;
#line 2456 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp16_;
		SudokuBoard* _tmp17_;
		SudokuBoard* _tmp18_;
#line 526 "../src/sudoku-cell.vala"
		_tmp16_ = self->priv->game;
#line 526 "../src/sudoku-cell.vala"
		_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 526 "../src/sudoku-cell.vala"
		_tmp18_ = _tmp17_;
#line 526 "../src/sudoku-cell.vala"
		_tmp13_ = sudoku_board_has_earmarks (_tmp18_, self->priv->row, self->priv->col);
#line 2469 "sudoku-cell.c"
	}
#line 526 "../src/sudoku-cell.vala"
	_tmp19_ = _data11_->number_picker;
#line 526 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp19_, _tmp13_);
#line 527 "../src/sudoku-cell.vala"
	_tmp20_ = sudoku_cell_get_popover (self);
#line 527 "../src/sudoku-cell.vala"
	_tmp21_ = _tmp20_;
#line 527 "../src/sudoku-cell.vala"
	_tmp22_ = _data11_->number_picker;
#line 527 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp21_, (GtkWidget*) _tmp22_);
#line 529 "../src/sudoku-cell.vala"
	_tmp23_ = sudoku_cell_get_popover (self);
#line 529 "../src/sudoku-cell.vala"
	_tmp24_ = _tmp23_;
#line 529 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp24_);
#line 504 "../src/sudoku-cell.vala"
	block11_data_unref (_data11_);
#line 504 "../src/sudoku-cell.vala"
	_data11_ = NULL;
#line 2493 "sudoku-cell.c"
}

void
sudoku_cell_check_warnings (SudokuCell* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _error_ = FALSE;
	gint solution = 0;
	SudokuGame* _tmp2_;
	GameMode _tmp3_;
	GameMode _tmp4_;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp10_;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	SudokuGame* _tmp22_;
	GameMode _tmp23_;
	GameMode _tmp24_;
	SudokuGame* _tmp29_;
	SudokuBoard* _tmp30_;
	SudokuBoard* _tmp31_;
	GeeSet* _tmp32_;
	GeeSet* _tmp33_;
	Coord _tmp34_ = {0};
	gint _tmp35_;
	gint _tmp36_;
	gboolean* marks = NULL;
	SudokuGame* _tmp37_;
	SudokuBoard* _tmp38_;
	SudokuBoard* _tmp39_;
	gint _tmp40_ = 0;
	gboolean* _tmp41_;
	gint marks_length1;
	gint _marks_size_;
#line 532 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 534 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_show_warnings (self);
#line 534 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 534 "../src/sudoku-cell.vala"
	if (!_tmp1_) {
#line 535 "../src/sudoku-cell.vala"
		return;
#line 2540 "sudoku-cell.c"
	}
#line 537 "../src/sudoku-cell.vala"
	_error_ = FALSE;
#line 538 "../src/sudoku-cell.vala"
	solution = 0;
#line 540 "../src/sudoku-cell.vala"
	_tmp2_ = self->priv->game;
#line 540 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_game_get_mode (_tmp2_);
#line 540 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 540 "../src/sudoku-cell.vala"
	if (_tmp4_ == GAME_MODE_PLAY) {
#line 2554 "sudoku-cell.c"
		SudokuGame* _tmp5_;
		SudokuBoard* _tmp6_;
		SudokuBoard* _tmp7_;
#line 541 "../src/sudoku-cell.vala"
		_tmp5_ = self->priv->game;
#line 541 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_game_get_board (_tmp5_);
#line 541 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 541 "../src/sudoku-cell.vala"
		solution = sudoku_board_get_solution (_tmp7_, self->priv->row, self->priv->col);
#line 2566 "sudoku-cell.c"
	}
#line 543 "../src/sudoku-cell.vala"
	_tmp9_ = sudoku_cell_get_value (self);
#line 543 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_;
#line 543 "../src/sudoku-cell.vala"
	if (_tmp10_ == 0) {
#line 2574 "sudoku-cell.c"
		SudokuGame* _tmp11_;
		SudokuBoard* _tmp12_;
		SudokuBoard* _tmp13_;
#line 543 "../src/sudoku-cell.vala"
		_tmp11_ = self->priv->game;
#line 543 "../src/sudoku-cell.vala"
		_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 543 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_;
#line 543 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_board_count_possibilities (_tmp13_, self->priv->row, self->priv->col) == 0;
#line 2586 "sudoku-cell.c"
	} else {
#line 543 "../src/sudoku-cell.vala"
		_tmp8_ = FALSE;
#line 2590 "sudoku-cell.c"
	}
#line 543 "../src/sudoku-cell.vala"
	if (_tmp8_) {
#line 2594 "sudoku-cell.c"
		GtkLabel* _tmp14_;
#line 544 "../src/sudoku-cell.vala"
		_tmp14_ = self->priv->value_label;
#line 544 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp14_, "X");
#line 2600 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 546 "../src/sudoku-cell.vala"
		_tmp15_ = self->priv->value_label;
#line 546 "../src/sudoku-cell.vala"
		_tmp16_ = sudoku_cell_get_value (self);
#line 546 "../src/sudoku-cell.vala"
		_tmp17_ = _tmp16_;
#line 546 "../src/sudoku-cell.vala"
		_tmp18_ = g_strdup_printf ("%i", _tmp17_);
#line 546 "../src/sudoku-cell.vala"
		_tmp19_ = _tmp18_;
#line 546 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp15_, _tmp19_);
#line 546 "../src/sudoku-cell.vala"
		_g_free0 (_tmp19_);
#line 2621 "sudoku-cell.c"
	}
#line 548 "../src/sudoku-cell.vala"
	_tmp22_ = self->priv->game;
#line 548 "../src/sudoku-cell.vala"
	_tmp23_ = sudoku_game_get_mode (_tmp22_);
#line 548 "../src/sudoku-cell.vala"
	_tmp24_ = _tmp23_;
#line 548 "../src/sudoku-cell.vala"
	if (_tmp24_ == GAME_MODE_PLAY) {
#line 548 "../src/sudoku-cell.vala"
		_tmp21_ = sudoku_cell_warn_incorrect_solution (self);
#line 2633 "sudoku-cell.c"
	} else {
#line 548 "../src/sudoku-cell.vala"
		_tmp21_ = FALSE;
#line 2637 "sudoku-cell.c"
	}
#line 548 "../src/sudoku-cell.vala"
	if (_tmp21_) {
#line 2641 "sudoku-cell.c"
		gint _tmp25_;
		gint _tmp26_;
#line 548 "../src/sudoku-cell.vala"
		_tmp25_ = sudoku_cell_get_value (self);
#line 548 "../src/sudoku-cell.vala"
		_tmp26_ = _tmp25_;
#line 548 "../src/sudoku-cell.vala"
		_tmp20_ = _tmp26_ != 0;
#line 2650 "sudoku-cell.c"
	} else {
#line 548 "../src/sudoku-cell.vala"
		_tmp20_ = FALSE;
#line 2654 "sudoku-cell.c"
	}
#line 548 "../src/sudoku-cell.vala"
	if (_tmp20_) {
#line 2658 "sudoku-cell.c"
		gint _tmp27_;
		gint _tmp28_;
#line 549 "../src/sudoku-cell.vala"
		_tmp27_ = sudoku_cell_get_value (self);
#line 549 "../src/sudoku-cell.vala"
		_tmp28_ = _tmp27_;
#line 549 "../src/sudoku-cell.vala"
		_error_ = _tmp28_ != solution;
#line 2667 "sudoku-cell.c"
	}
#line 551 "../src/sudoku-cell.vala"
	_tmp29_ = self->priv->game;
#line 551 "../src/sudoku-cell.vala"
	_tmp30_ = sudoku_game_get_board (_tmp29_);
#line 551 "../src/sudoku-cell.vala"
	_tmp31_ = _tmp30_;
#line 551 "../src/sudoku-cell.vala"
	_tmp32_ = sudoku_board_get_broken_coords (_tmp31_);
#line 551 "../src/sudoku-cell.vala"
	_tmp33_ = _tmp32_;
#line 551 "../src/sudoku-cell.vala"
	coord_init (&_tmp34_, self->priv->row, self->priv->col);
#line 551 "../src/sudoku-cell.vala"
	if (gee_collection_contains ((GeeCollection*) _tmp33_, &_tmp34_)) {
#line 552 "../src/sudoku-cell.vala"
		_error_ = TRUE;
#line 2685 "sudoku-cell.c"
	}
#line 554 "../src/sudoku-cell.vala"
	if (_error_) {
#line 555 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "error");
#line 2691 "sudoku-cell.c"
	} else {
#line 557 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "error");
#line 2695 "sudoku-cell.c"
	}
#line 559 "../src/sudoku-cell.vala"
	_tmp35_ = sudoku_cell_get_value (self);
#line 559 "../src/sudoku-cell.vala"
	_tmp36_ = _tmp35_;
#line 559 "../src/sudoku-cell.vala"
	if (_tmp36_ != 0) {
#line 560 "../src/sudoku-cell.vala"
		return;
#line 2705 "sudoku-cell.c"
	}
#line 562 "../src/sudoku-cell.vala"
	_tmp37_ = self->priv->game;
#line 562 "../src/sudoku-cell.vala"
	_tmp38_ = sudoku_game_get_board (_tmp37_);
#line 562 "../src/sudoku-cell.vala"
	_tmp39_ = _tmp38_;
#line 562 "../src/sudoku-cell.vala"
	_tmp41_ = sudoku_board_get_earmarks (_tmp39_, self->priv->row, self->priv->col, &_tmp40_);
#line 562 "../src/sudoku-cell.vala"
	marks = _tmp41_;
#line 562 "../src/sudoku-cell.vala"
	marks_length1 = _tmp40_;
#line 562 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 2721 "sudoku-cell.c"
	{
		gint num = 0;
#line 563 "../src/sudoku-cell.vala"
		num = 1;
#line 2726 "sudoku-cell.c"
		{
			gboolean _tmp42_ = FALSE;
#line 563 "../src/sudoku-cell.vala"
			_tmp42_ = TRUE;
#line 563 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2733 "sudoku-cell.c"
				gboolean* _tmp44_;
				gint _tmp44__length1;
				gboolean* _tmp45_;
				gint _tmp45__length1;
				gboolean _tmp46_;
#line 563 "../src/sudoku-cell.vala"
				if (!_tmp42_) {
#line 2741 "sudoku-cell.c"
					gint _tmp43_;
#line 563 "../src/sudoku-cell.vala"
					_tmp43_ = num;
#line 563 "../src/sudoku-cell.vala"
					num = _tmp43_ + 1;
#line 2747 "sudoku-cell.c"
				}
#line 563 "../src/sudoku-cell.vala"
				_tmp42_ = FALSE;
#line 563 "../src/sudoku-cell.vala"
				_tmp44_ = marks;
#line 563 "../src/sudoku-cell.vala"
				_tmp44__length1 = marks_length1;
#line 563 "../src/sudoku-cell.vala"
				if (!(num <= _tmp44__length1)) {
#line 563 "../src/sudoku-cell.vala"
					break;
#line 2759 "sudoku-cell.c"
				}
#line 565 "../src/sudoku-cell.vala"
				_tmp45_ = marks;
#line 565 "../src/sudoku-cell.vala"
				_tmp45__length1 = marks_length1;
#line 565 "../src/sudoku-cell.vala"
				_tmp46_ = _tmp45_[num - 1];
#line 565 "../src/sudoku-cell.vala"
				if (_tmp46_) {
#line 2769 "sudoku-cell.c"
					gboolean _tmp47_ = FALSE;
					SudokuGame* _tmp48_;
					SudokuBoard* _tmp49_;
					SudokuBoard* _tmp50_;
#line 567 "../src/sudoku-cell.vala"
					_tmp48_ = self->priv->game;
#line 567 "../src/sudoku-cell.vala"
					_tmp49_ = sudoku_game_get_board (_tmp48_);
#line 567 "../src/sudoku-cell.vala"
					_tmp50_ = _tmp49_;
#line 567 "../src/sudoku-cell.vala"
					if (!sudoku_board_is_possible (_tmp50_, self->priv->row, self->priv->col, num)) {
#line 567 "../src/sudoku-cell.vala"
						_tmp47_ = TRUE;
#line 2784 "sudoku-cell.c"
					} else {
						gboolean _tmp51_ = FALSE;
						gboolean _tmp52_ = FALSE;
						SudokuGame* _tmp53_;
						GameMode _tmp54_;
						GameMode _tmp55_;
#line 568 "../src/sudoku-cell.vala"
						_tmp53_ = self->priv->game;
#line 568 "../src/sudoku-cell.vala"
						_tmp54_ = sudoku_game_get_mode (_tmp53_);
#line 568 "../src/sudoku-cell.vala"
						_tmp55_ = _tmp54_;
#line 568 "../src/sudoku-cell.vala"
						if (_tmp55_ == GAME_MODE_PLAY) {
#line 568 "../src/sudoku-cell.vala"
							_tmp52_ = sudoku_cell_warn_incorrect_solution (self);
#line 2801 "sudoku-cell.c"
						} else {
#line 568 "../src/sudoku-cell.vala"
							_tmp52_ = FALSE;
#line 2805 "sudoku-cell.c"
						}
#line 568 "../src/sudoku-cell.vala"
						if (_tmp52_) {
#line 568 "../src/sudoku-cell.vala"
							_tmp51_ = num != solution;
#line 2811 "sudoku-cell.c"
						} else {
#line 568 "../src/sudoku-cell.vala"
							_tmp51_ = FALSE;
#line 2815 "sudoku-cell.c"
						}
#line 568 "../src/sudoku-cell.vala"
						_tmp47_ = _tmp51_;
#line 2819 "sudoku-cell.c"
					}
#line 567 "../src/sudoku-cell.vala"
					if (_tmp47_) {
#line 2823 "sudoku-cell.c"
						GtkLabel** _tmp56_;
						gint _tmp56__length1;
						GtkLabel* _tmp57_;
#line 570 "../src/sudoku-cell.vala"
						_tmp56_ = self->priv->earmark_labels;
#line 570 "../src/sudoku-cell.vala"
						_tmp56__length1 = self->priv->earmark_labels_length1;
#line 570 "../src/sudoku-cell.vala"
						_tmp57_ = _tmp56_[num - 1];
#line 570 "../src/sudoku-cell.vala"
						gtk_widget_add_css_class ((GtkWidget*) _tmp57_, "error");
#line 2835 "sudoku-cell.c"
					} else {
						GtkLabel** _tmp58_;
						gint _tmp58__length1;
						GtkLabel* _tmp59_;
#line 573 "../src/sudoku-cell.vala"
						_tmp58_ = self->priv->earmark_labels;
#line 573 "../src/sudoku-cell.vala"
						_tmp58__length1 = self->priv->earmark_labels_length1;
#line 573 "../src/sudoku-cell.vala"
						_tmp59_ = _tmp58_[num - 1];
#line 573 "../src/sudoku-cell.vala"
						gtk_widget_remove_css_class ((GtkWidget*) _tmp59_, "error");
#line 2848 "sudoku-cell.c"
					}
				}
			}
		}
	}
#line 532 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2856 "sudoku-cell.c"
}

void
sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                    gint num,
                                    gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gint solution = 0;
	SudokuGame* _tmp10_;
	SudokuBoard* _tmp11_;
	SudokuBoard* _tmp12_;
	gboolean _tmp13_ = FALSE;
	SudokuGame* _tmp14_;
	SudokuBoard* _tmp15_;
	SudokuBoard* _tmp16_;
#line 578 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 580 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_cell_get_show_warnings (self);
#line 580 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 580 "../src/sudoku-cell.vala"
	if (!_tmp4_) {
#line 580 "../src/sudoku-cell.vala"
		_tmp2_ = TRUE;
#line 2887 "sudoku-cell.c"
	} else {
#line 580 "../src/sudoku-cell.vala"
		_tmp2_ = !enabled;
#line 2891 "sudoku-cell.c"
	}
#line 580 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 580 "../src/sudoku-cell.vala"
		_tmp1_ = TRUE;
#line 2897 "sudoku-cell.c"
	} else {
		gint _tmp5_;
		gint _tmp6_;
#line 580 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_cell_get_value (self);
#line 580 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 580 "../src/sudoku-cell.vala"
		_tmp1_ = _tmp6_ != 0;
#line 2907 "sudoku-cell.c"
	}
#line 580 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 580 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 2913 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp7_;
		GameMode _tmp8_;
		GameMode _tmp9_;
#line 580 "../src/sudoku-cell.vala"
		_tmp7_ = self->priv->game;
#line 580 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_game_get_mode (_tmp7_);
#line 580 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 580 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp9_ != GAME_MODE_PLAY;
#line 2926 "sudoku-cell.c"
	}
#line 580 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 581 "../src/sudoku-cell.vala"
		return;
#line 2932 "sudoku-cell.c"
	}
#line 583 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->game;
#line 583 "../src/sudoku-cell.vala"
	_tmp11_ = sudoku_game_get_board (_tmp10_);
#line 583 "../src/sudoku-cell.vala"
	_tmp12_ = _tmp11_;
#line 583 "../src/sudoku-cell.vala"
	solution = sudoku_board_get_solution (_tmp12_, self->priv->row, self->priv->col);
#line 585 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->game;
#line 585 "../src/sudoku-cell.vala"
	_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 585 "../src/sudoku-cell.vala"
	_tmp16_ = _tmp15_;
#line 585 "../src/sudoku-cell.vala"
	if (!sudoku_board_is_possible (_tmp16_, self->priv->row, self->priv->col, num)) {
#line 585 "../src/sudoku-cell.vala"
		_tmp13_ = TRUE;
#line 2952 "sudoku-cell.c"
	} else {
		gboolean _tmp17_ = FALSE;
#line 585 "../src/sudoku-cell.vala"
		if (sudoku_cell_warn_incorrect_solution (self)) {
#line 585 "../src/sudoku-cell.vala"
			_tmp17_ = num != solution;
#line 2959 "sudoku-cell.c"
		} else {
#line 585 "../src/sudoku-cell.vala"
			_tmp17_ = FALSE;
#line 2963 "sudoku-cell.c"
		}
#line 585 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp17_;
#line 2967 "sudoku-cell.c"
	}
#line 585 "../src/sudoku-cell.vala"
	if (_tmp13_) {
#line 2971 "sudoku-cell.c"
		GtkLabel** _tmp18_;
		gint _tmp18__length1;
		GtkLabel* _tmp19_;
#line 586 "../src/sudoku-cell.vala"
		_tmp18_ = self->priv->earmark_labels;
#line 586 "../src/sudoku-cell.vala"
		_tmp18__length1 = self->priv->earmark_labels_length1;
#line 586 "../src/sudoku-cell.vala"
		_tmp19_ = _tmp18_[num - 1];
#line 586 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "error");
#line 2983 "sudoku-cell.c"
	} else {
		GtkLabel** _tmp20_;
		gint _tmp20__length1;
		GtkLabel* _tmp21_;
#line 588 "../src/sudoku-cell.vala"
		_tmp20_ = self->priv->earmark_labels;
#line 588 "../src/sudoku-cell.vala"
		_tmp20__length1 = self->priv->earmark_labels_length1;
#line 588 "../src/sudoku-cell.vala"
		_tmp21_ = _tmp20_[num - 1];
#line 588 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp21_, "error");
#line 2996 "sudoku-cell.c"
	}
}

void
sudoku_cell_clear_warnings (SudokuCell* self)
{
	gboolean* marks = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_ = 0;
	gboolean* _tmp4_;
	gint marks_length1;
	gint _marks_size_;
	GtkLabel* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 591 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 593 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 593 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 593 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 593 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_board_get_earmarks (_tmp2_, self->priv->row, self->priv->col, &_tmp3_);
#line 593 "../src/sudoku-cell.vala"
	marks = _tmp4_;
#line 593 "../src/sudoku-cell.vala"
	marks_length1 = _tmp3_;
#line 593 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 594 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->value_label;
#line 594 "../src/sudoku-cell.vala"
	_tmp6_ = sudoku_cell_get_value (self);
#line 594 "../src/sudoku-cell.vala"
	_tmp7_ = _tmp6_;
#line 594 "../src/sudoku-cell.vala"
	_tmp8_ = g_strdup_printf ("%i", _tmp7_);
#line 594 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_;
#line 594 "../src/sudoku-cell.vala"
	gtk_label_set_label (_tmp5_, _tmp9_);
#line 594 "../src/sudoku-cell.vala"
	_g_free0 (_tmp9_);
#line 595 "../src/sudoku-cell.vala"
	gtk_widget_remove_css_class ((GtkWidget*) self, "error");
#line 3048 "sudoku-cell.c"
	{
		gint num = 0;
#line 596 "../src/sudoku-cell.vala"
		num = 1;
#line 3053 "sudoku-cell.c"
		{
			gboolean _tmp10_ = FALSE;
#line 596 "../src/sudoku-cell.vala"
			_tmp10_ = TRUE;
#line 596 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 3060 "sudoku-cell.c"
				gboolean* _tmp12_;
				gint _tmp12__length1;
				GtkLabel** _tmp13_;
				gint _tmp13__length1;
				GtkLabel* _tmp14_;
#line 596 "../src/sudoku-cell.vala"
				if (!_tmp10_) {
#line 3068 "sudoku-cell.c"
					gint _tmp11_;
#line 596 "../src/sudoku-cell.vala"
					_tmp11_ = num;
#line 596 "../src/sudoku-cell.vala"
					num = _tmp11_ + 1;
#line 3074 "sudoku-cell.c"
				}
#line 596 "../src/sudoku-cell.vala"
				_tmp10_ = FALSE;
#line 596 "../src/sudoku-cell.vala"
				_tmp12_ = marks;
#line 596 "../src/sudoku-cell.vala"
				_tmp12__length1 = marks_length1;
#line 596 "../src/sudoku-cell.vala"
				if (!(num <= _tmp12__length1)) {
#line 596 "../src/sudoku-cell.vala"
					break;
#line 3086 "sudoku-cell.c"
				}
#line 597 "../src/sudoku-cell.vala"
				_tmp13_ = self->priv->earmark_labels;
#line 597 "../src/sudoku-cell.vala"
				_tmp13__length1 = self->priv->earmark_labels_length1;
#line 597 "../src/sudoku-cell.vala"
				_tmp14_ = _tmp13_[num - 1];
#line 597 "../src/sudoku-cell.vala"
				gtk_widget_remove_css_class ((GtkWidget*) _tmp14_, "error");
#line 3096 "sudoku-cell.c"
			}
		}
	}
#line 591 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 3102 "sudoku-cell.c"
}

static gboolean
sudoku_cell_warn_incorrect_solution (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 603 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 609 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_show_extra_warnings (self);
#line 609 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 609 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 610 "../src/sudoku-cell.vala"
		_tmp1_ = !self->priv->control_key_pressed;
#line 3123 "sudoku-cell.c"
	} else {
#line 609 "../src/sudoku-cell.vala"
		_tmp1_ = FALSE;
#line 3127 "sudoku-cell.c"
	}
#line 609 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 3131 "sudoku-cell.c"
		SudokuGame* _tmp4_;
		SudokuBoard* _tmp5_;
		SudokuBoard* _tmp6_;
#line 611 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->game;
#line 611 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_game_get_board (_tmp4_);
#line 611 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 611 "../src/sudoku-cell.vala"
		_tmp0_ = sudoku_board_solved (_tmp6_);
#line 3143 "sudoku-cell.c"
	} else {
#line 609 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 3147 "sudoku-cell.c"
	}
#line 609 "../src/sudoku-cell.vala"
	result = _tmp0_;
#line 609 "../src/sudoku-cell.vala"
	return result;
#line 3153 "sudoku-cell.c"
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
#line 614 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 616 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 618 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->value_label;
#line 618 "../src/sudoku-cell.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 3169 "sudoku-cell.c"
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 636 "../src/sudoku-cell.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 3177 "sudoku-cell.c"
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gint value_width = 0;
	gint value_height = 0;
	GskTransform* center = NULL;
	GskTransform* _tmp2_;
	graphene_point_t _tmp3_ = {0};
	graphene_point_t _tmp4_;
	GskTransform* _tmp5_;
	GtkLabel* _tmp6_;
	GskTransform* _tmp7_;
	GskTransform* _tmp8_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	SudokuBoard* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	SudokuGame* _tmp14_;
	SudokuBoard* _tmp15_;
	SudokuBoard* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint num = 0;
#line 621 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 625 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 625 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 625 "../src/sudoku-cell.vala"
	gtk_popover_present (_tmp1_);
#line 628 "../src/sudoku-cell.vala"
	value_height = MIN (width, height);
#line 628 "../src/sudoku-cell.vala"
	value_width = value_height;
#line 630 "../src/sudoku-cell.vala"
	sudoku_cell_set_font_size (self, &self->priv->value_label, height / SUDOKU_CELL_size_ratio);
#line 632 "../src/sudoku-cell.vala"
	_tmp2_ = gsk_transform_new ();
#line 632 "../src/sudoku-cell.vala"
	memset (&_tmp3_, 0, sizeof (graphene_point_t));
#line 632 "../src/sudoku-cell.vala"
	_tmp4_ = *graphene_point_init (&_tmp3_, (gfloat) ((width - value_width) / 2), (gfloat) ((height - value_height) / 2));
#line 632 "../src/sudoku-cell.vala"
	_tmp5_ = gsk_transform_translate (_tmp2_, &_tmp4_);
#line 632 "../src/sudoku-cell.vala"
	center = _tmp5_;
#line 636 "../src/sudoku-cell.vala"
	_tmp6_ = self->priv->value_label;
#line 636 "../src/sudoku-cell.vala"
	_tmp7_ = center;
#line 636 "../src/sudoku-cell.vala"
	_tmp8_ = _gsk_transform_ref0 (_tmp7_);
#line 636 "../src/sudoku-cell.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp6_, value_width, value_height, baseline, _tmp8_);
#line 639 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->game;
#line 639 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 639 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 639 "../src/sudoku-cell.vala"
	_tmp12_ = sudoku_board_get_block_cols (_tmp11_);
#line 639 "../src/sudoku-cell.vala"
	_tmp13_ = _tmp12_;
#line 639 "../src/sudoku-cell.vala"
	earmark_width = width / _tmp13_;
#line 640 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->game;
#line 640 "../src/sudoku-cell.vala"
	_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 640 "../src/sudoku-cell.vala"
	_tmp16_ = _tmp15_;
#line 640 "../src/sudoku-cell.vala"
	_tmp17_ = sudoku_board_get_block_rows (_tmp16_);
#line 640 "../src/sudoku-cell.vala"
	_tmp18_ = _tmp17_;
#line 640 "../src/sudoku-cell.vala"
	earmark_height = height / _tmp18_;
#line 642 "../src/sudoku-cell.vala"
	num = 0;
#line 3270 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 643 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 3275 "sudoku-cell.c"
		{
			gboolean _tmp19_ = FALSE;
#line 643 "../src/sudoku-cell.vala"
			_tmp19_ = TRUE;
#line 643 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 3282 "sudoku-cell.c"
				SudokuGame* _tmp21_;
				SudokuBoard* _tmp22_;
				SudokuBoard* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
#line 643 "../src/sudoku-cell.vala"
				if (!_tmp19_) {
#line 3290 "sudoku-cell.c"
					gint _tmp20_;
#line 643 "../src/sudoku-cell.vala"
					_tmp20_ = row_tmp;
#line 643 "../src/sudoku-cell.vala"
					row_tmp = _tmp20_ + 1;
#line 3296 "sudoku-cell.c"
				}
#line 643 "../src/sudoku-cell.vala"
				_tmp19_ = FALSE;
#line 643 "../src/sudoku-cell.vala"
				_tmp21_ = self->priv->game;
#line 643 "../src/sudoku-cell.vala"
				_tmp22_ = sudoku_game_get_board (_tmp21_);
#line 643 "../src/sudoku-cell.vala"
				_tmp23_ = _tmp22_;
#line 643 "../src/sudoku-cell.vala"
				_tmp24_ = sudoku_board_get_block_rows (_tmp23_);
#line 643 "../src/sudoku-cell.vala"
				_tmp25_ = _tmp24_;
#line 643 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp25_)) {
#line 643 "../src/sudoku-cell.vala"
					break;
#line 3314 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 645 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 3320 "sudoku-cell.c"
					{
						gboolean _tmp26_ = FALSE;
#line 645 "../src/sudoku-cell.vala"
						_tmp26_ = TRUE;
#line 645 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 3327 "sudoku-cell.c"
							SudokuGame* _tmp28_;
							SudokuBoard* _tmp29_;
							SudokuBoard* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkLabel** _tmp34_;
							gint _tmp34__length1;
							GskTransform* earmark_position = NULL;
							GskTransform* _tmp35_;
							graphene_point_t _tmp36_ = {0};
							SudokuGame* _tmp37_;
							SudokuBoard* _tmp38_;
							SudokuBoard* _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							graphene_point_t _tmp42_;
							GskTransform* _tmp43_;
							GtkLabel** _tmp44_;
							gint _tmp44__length1;
							GtkLabel* _tmp45_;
							GskTransform* _tmp46_;
							GskTransform* _tmp47_;
#line 645 "../src/sudoku-cell.vala"
							if (!_tmp26_) {
#line 3353 "sudoku-cell.c"
								gint _tmp27_;
#line 645 "../src/sudoku-cell.vala"
								_tmp27_ = col_tmp;
#line 645 "../src/sudoku-cell.vala"
								col_tmp = _tmp27_ + 1;
#line 3359 "sudoku-cell.c"
							}
#line 645 "../src/sudoku-cell.vala"
							_tmp26_ = FALSE;
#line 645 "../src/sudoku-cell.vala"
							_tmp28_ = self->priv->game;
#line 645 "../src/sudoku-cell.vala"
							_tmp29_ = sudoku_game_get_board (_tmp28_);
#line 645 "../src/sudoku-cell.vala"
							_tmp30_ = _tmp29_;
#line 645 "../src/sudoku-cell.vala"
							_tmp31_ = sudoku_board_get_block_cols (_tmp30_);
#line 645 "../src/sudoku-cell.vala"
							_tmp32_ = _tmp31_;
#line 645 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp32_)) {
#line 645 "../src/sudoku-cell.vala"
								break;
#line 3377 "sudoku-cell.c"
							}
#line 647 "../src/sudoku-cell.vala"
							_tmp33_ = num;
#line 647 "../src/sudoku-cell.vala"
							num = _tmp33_ + 1;
#line 649 "../src/sudoku-cell.vala"
							_tmp34_ = self->priv->earmark_labels;
#line 649 "../src/sudoku-cell.vala"
							_tmp34__length1 = self->priv->earmark_labels_length1;
#line 649 "../src/sudoku-cell.vala"
							sudoku_cell_set_font_size (self, &_tmp34_[num - 1], (height / SUDOKU_CELL_size_ratio) / 2);
#line 651 "../src/sudoku-cell.vala"
							_tmp35_ = gsk_transform_new ();
#line 651 "../src/sudoku-cell.vala"
							memset (&_tmp36_, 0, sizeof (graphene_point_t));
#line 651 "../src/sudoku-cell.vala"
							_tmp37_ = self->priv->game;
#line 651 "../src/sudoku-cell.vala"
							_tmp38_ = sudoku_game_get_board (_tmp37_);
#line 651 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_;
#line 651 "../src/sudoku-cell.vala"
							_tmp40_ = sudoku_board_get_block_rows (_tmp39_);
#line 651 "../src/sudoku-cell.vala"
							_tmp41_ = _tmp40_;
#line 651 "../src/sudoku-cell.vala"
							_tmp42_ = *graphene_point_init (&_tmp36_, (gfloat) (col_tmp * earmark_width), (gfloat) (((_tmp41_ - row_tmp) - 1) * earmark_height));
#line 651 "../src/sudoku-cell.vala"
							_tmp43_ = gsk_transform_translate (_tmp35_, &_tmp42_);
#line 651 "../src/sudoku-cell.vala"
							earmark_position = _tmp43_;
#line 656 "../src/sudoku-cell.vala"
							_tmp44_ = self->priv->earmark_labels;
#line 656 "../src/sudoku-cell.vala"
							_tmp44__length1 = self->priv->earmark_labels_length1;
#line 656 "../src/sudoku-cell.vala"
							_tmp45_ = _tmp44_[num - 1];
#line 656 "../src/sudoku-cell.vala"
							_tmp46_ = earmark_position;
#line 656 "../src/sudoku-cell.vala"
							_tmp47_ = _gsk_transform_ref0 (_tmp46_);
#line 656 "../src/sudoku-cell.vala"
							gtk_widget_allocate ((GtkWidget*) _tmp45_, earmark_width, earmark_height, baseline, _tmp47_);
#line 645 "../src/sudoku-cell.vala"
							_gsk_transform_unref0 (earmark_position);
#line 3423 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 621 "../src/sudoku-cell.vala"
	_gsk_transform_unref0 (center);
#line 3432 "sudoku-cell.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 663 "../src/sudoku-cell.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 3440 "sudoku-cell.c"
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel** label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
#line 661 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 661 "../src/sudoku-cell.vala"
	g_return_if_fail (*label != NULL);
#line 663 "../src/sudoku-cell.vala"
	_tmp0_ = gtk_label_get_attributes (*label);
#line 663 "../src/sudoku-cell.vala"
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
#line 663 "../src/sudoku-cell.vala"
	attr_list = _tmp1_;
#line 664 "../src/sudoku-cell.vala"
	_tmp2_ = attr_list;
#line 664 "../src/sudoku-cell.vala"
	if (_tmp2_ == NULL) {
#line 3469 "sudoku-cell.c"
		PangoAttrList* _tmp3_;
#line 665 "../src/sudoku-cell.vala"
		_tmp3_ = pango_attr_list_new ();
#line 665 "../src/sudoku-cell.vala"
		_pango_attr_list_unref0 (attr_list);
#line 665 "../src/sudoku-cell.vala"
		attr_list = _tmp3_;
#line 3477 "sudoku-cell.c"
	}
#line 667 "../src/sudoku-cell.vala"
	_tmp4_ = attr_list;
#line 667 "../src/sudoku-cell.vala"
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
#line 667 "../src/sudoku-cell.vala"
	pango_attr_list_change (_tmp4_, _tmp5_);
#line 671 "../src/sudoku-cell.vala"
	_tmp6_ = attr_list;
#line 671 "../src/sudoku-cell.vala"
	gtk_label_set_attributes (*label, _tmp6_);
#line 661 "../src/sudoku-cell.vala"
	_pango_attr_list_unref0 (attr_list);
#line 3491 "sudoku-cell.c"
}

void
sudoku_cell_dismiss_popover (SudokuCell* self)
{
	GtkPopover* _tmp0_;
#line 674 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 676 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->_popover;
#line 676 "../src/sudoku-cell.vala"
	if (_tmp0_ != NULL) {
#line 3504 "sudoku-cell.c"
		GtkPopover* _tmp1_;
#line 677 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->_popover;
#line 677 "../src/sudoku-cell.vala"
		gtk_popover_popdown (_tmp1_);
#line 3510 "sudoku-cell.c"
	}
}

GtkPopover*
sudoku_cell_get_popover (SudokuCell* self)
{
	GtkPopover* result;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp3_;
#line 41 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->_popover;
#line 42 "../src/sudoku-cell.vala"
	if (_tmp0_ == NULL) {
#line 3526 "sudoku-cell.c"
		GtkPopover* _tmp1_;
		GtkPopover* _tmp2_;
#line 44 "../src/sudoku-cell.vala"
		_tmp1_ = (GtkPopover*) gtk_popover_new ();
#line 44 "../src/sudoku-cell.vala"
		g_object_ref_sink (_tmp1_);
#line 44 "../src/sudoku-cell.vala"
		_g_object_unref0 (self->priv->_popover);
#line 44 "../src/sudoku-cell.vala"
		self->priv->_popover = _tmp1_;
#line 45 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->_popover;
#line 45 "../src/sudoku-cell.vala"
		gtk_popover_set_autohide (_tmp2_, FALSE);
#line 3541 "sudoku-cell.c"
	}
#line 47 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->_popover;
#line 47 "../src/sudoku-cell.vala"
	result = _tmp3_;
#line 47 "../src/sudoku-cell.vala"
	return result;
#line 3549 "sudoku-cell.c"
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 60 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 60 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 60 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 60 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 60 "../src/sudoku-cell.vala"
	result = sudoku_board_get (_tmp2_, self->priv->row, self->priv->col);
#line 60 "../src/sudoku-cell.vala"
	return result;
#line 3571 "sudoku-cell.c"
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	SudokuBoard* _tmp3_;
#line 61 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 62 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_game_get_board (_tmp1_);
#line 62 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 62 "../src/sudoku-cell.vala"
	if (value == sudoku_board_get (_tmp3_, self->priv->row, self->priv->col)) {
#line 62 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 3594 "sudoku-cell.c"
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 62 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_is_fixed (self);
#line 62 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 62 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp5_;
#line 3604 "sudoku-cell.c"
	}
#line 62 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 65 "../src/sudoku-cell.vala"
		return;
#line 3610 "sudoku-cell.c"
	}
#line 68 "../src/sudoku-cell.vala"
	if (value != 0) {
#line 3614 "sudoku-cell.c"
		GtkLabel* _tmp6_;
#line 69 "../src/sudoku-cell.vala"
		_tmp6_ = self->priv->value_label;
#line 69 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
#line 3620 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp7_;
#line 71 "../src/sudoku-cell.vala"
		_tmp7_ = self->priv->value_label;
#line 71 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 3627 "sudoku-cell.c"
	}
#line 73 "../src/sudoku-cell.vala"
	if (value == 0) {
#line 3631 "sudoku-cell.c"
		SudokuGame* _tmp8_;
		SudokuBoard* _tmp9_;
		SudokuBoard* _tmp10_;
#line 75 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->game;
#line 75 "../src/sudoku-cell.vala"
		_tmp9_ = sudoku_game_get_board (_tmp8_);
#line 75 "../src/sudoku-cell.vala"
		_tmp10_ = _tmp9_;
#line 75 "../src/sudoku-cell.vala"
		if (sudoku_board_get (_tmp10_, self->priv->row, self->priv->col) != 0) {
#line 3643 "sudoku-cell.c"
			SudokuGame* _tmp11_;
#line 76 "../src/sudoku-cell.vala"
			_tmp11_ = self->priv->game;
#line 76 "../src/sudoku-cell.vala"
			sudoku_game_remove (_tmp11_, self->priv->row, self->priv->col);
#line 3649 "sudoku-cell.c"
		}
	} else {
		GtkLabel* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		SudokuGame* _tmp15_;
#line 80 "../src/sudoku-cell.vala"
		_tmp12_ = self->priv->value_label;
#line 80 "../src/sudoku-cell.vala"
		_tmp13_ = g_strdup_printf ("%i", value);
#line 80 "../src/sudoku-cell.vala"
		_tmp14_ = _tmp13_;
#line 80 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp12_, _tmp14_);
#line 80 "../src/sudoku-cell.vala"
		_g_free0 (_tmp14_);
#line 81 "../src/sudoku-cell.vala"
		_tmp15_ = self->priv->game;
#line 81 "../src/sudoku-cell.vala"
		sudoku_game_insert (_tmp15_, self->priv->row, self->priv->col, value);
#line 3670 "sudoku-cell.c"
	}
#line 61 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
#line 3674 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 88 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 88 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 88 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 88 "../src/sudoku-cell.vala"
	result = sudoku_board_get_is_fixed (_tmp2_, self->priv->row, self->priv->col);
#line 88 "../src/sudoku-cell.vala"
	return result;
#line 3696 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
#line 93 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../src/sudoku-cell.vala"
	result = self->priv->_selected;
#line 93 "../src/sudoku-cell.vala"
	return result;
#line 3709 "sudoku-cell.c"
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
#line 94 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/sudoku-cell.vala"
	self->priv->_selected = value;
#line 97 "../src/sudoku-cell.vala"
	if (value) {
#line 3722 "sudoku-cell.c"
		gchar* _tmp0_;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
#line 98 "../src/sudoku-cell.vala"
		_tmp0_ = g_strdup ("selected");
#line 98 "../src/sudoku-cell.vala"
		_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 98 "../src/sudoku-cell.vala"
		_tmp1_[0] = _tmp0_;
#line 98 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp1_;
#line 98 "../src/sudoku-cell.vala"
		_tmp2__length1 = 1;
#line 98 "../src/sudoku-cell.vala"
		gtk_widget_set_css_classes ((GtkWidget*) self, _tmp2_);
#line 98 "../src/sudoku-cell.vala"
		_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 3741 "sudoku-cell.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 99 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_cell_get_is_fixed (self);
#line 99 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 99 "../src/sudoku-cell.vala"
		if (_tmp4_) {
#line 3751 "sudoku-cell.c"
			gchar* _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
#line 100 "../src/sudoku-cell.vala"
			_tmp5_ = g_strdup ("fixed");
#line 100 "../src/sudoku-cell.vala"
			_tmp6_ = g_new0 (gchar*, 1 + 1);
#line 100 "../src/sudoku-cell.vala"
			_tmp6_[0] = _tmp5_;
#line 100 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp6_;
#line 100 "../src/sudoku-cell.vala"
			_tmp7__length1 = 1;
#line 100 "../src/sudoku-cell.vala"
			gtk_widget_set_css_classes ((GtkWidget*) self, _tmp7_);
#line 100 "../src/sudoku-cell.vala"
			_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 3770 "sudoku-cell.c"
		} else {
			gchar** _tmp8_;
			gchar** _tmp9_;
			gint _tmp9__length1;
#line 101 "../src/sudoku-cell.vala"
			_tmp8_ = g_new0 (gchar*, 0 + 1);
#line 101 "../src/sudoku-cell.vala"
			_tmp9_ = _tmp8_;
#line 101 "../src/sudoku-cell.vala"
			_tmp9__length1 = 0;
#line 101 "../src/sudoku-cell.vala"
			gtk_widget_set_css_classes ((GtkWidget*) self, _tmp9_);
#line 101 "../src/sudoku-cell.vala"
			_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 3785 "sudoku-cell.c"
		}
	}
#line 94 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
#line 3790 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_background (SudokuCell* self)
{
	gboolean result;
#line 107 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_background;
#line 107 "../src/sudoku-cell.vala"
	return result;
#line 3803 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_background (SudokuCell* self,
                                        gboolean value)
{
#line 108 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = value;
#line 111 "../src/sudoku-cell.vala"
	if (value) {
#line 3816 "sudoku-cell.c"
		gchar* _tmp0_;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
#line 112 "../src/sudoku-cell.vala"
		_tmp0_ = g_strdup ("highlight-bg");
#line 112 "../src/sudoku-cell.vala"
		_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 112 "../src/sudoku-cell.vala"
		_tmp1_[0] = _tmp0_;
#line 112 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp1_;
#line 112 "../src/sudoku-cell.vala"
		_tmp2__length1 = 1;
#line 112 "../src/sudoku-cell.vala"
		gtk_widget_set_css_classes ((GtkWidget*) self, _tmp2_);
#line 112 "../src/sudoku-cell.vala"
		_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 3835 "sudoku-cell.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 113 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_cell_get_is_fixed (self);
#line 113 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 113 "../src/sudoku-cell.vala"
		if (_tmp4_) {
#line 3845 "sudoku-cell.c"
			gchar* _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
#line 114 "../src/sudoku-cell.vala"
			_tmp5_ = g_strdup ("fixed");
#line 114 "../src/sudoku-cell.vala"
			_tmp6_ = g_new0 (gchar*, 1 + 1);
#line 114 "../src/sudoku-cell.vala"
			_tmp6_[0] = _tmp5_;
#line 114 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp6_;
#line 114 "../src/sudoku-cell.vala"
			_tmp7__length1 = 1;
#line 114 "../src/sudoku-cell.vala"
			gtk_widget_set_css_classes ((GtkWidget*) self, _tmp7_);
#line 114 "../src/sudoku-cell.vala"
			_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 3864 "sudoku-cell.c"
		} else {
			gchar** _tmp8_;
			gchar** _tmp9_;
			gint _tmp9__length1;
#line 115 "../src/sudoku-cell.vala"
			_tmp8_ = g_new0 (gchar*, 0 + 1);
#line 115 "../src/sudoku-cell.vala"
			_tmp9_ = _tmp8_;
#line 115 "../src/sudoku-cell.vala"
			_tmp9__length1 = 0;
#line 115 "../src/sudoku-cell.vala"
			gtk_widget_set_css_classes ((GtkWidget*) self, _tmp9_);
#line 115 "../src/sudoku-cell.vala"
			_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 3879 "sudoku-cell.c"
		}
	}
#line 108 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY]);
#line 3884 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_value (SudokuCell* self)
{
	gboolean result;
#line 121 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 121 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_value;
#line 121 "../src/sudoku-cell.vala"
	return result;
#line 3897 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_value (SudokuCell* self,
                                   gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 122 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = value;
#line 125 "../src/sudoku-cell.vala"
	if (value) {
#line 125 "../src/sudoku-cell.vala"
		_tmp0_ = !gtk_widget_has_css_class ((GtkWidget*) self, "error");
#line 3913 "sudoku-cell.c"
	} else {
#line 125 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 3917 "sudoku-cell.c"
	}
#line 125 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 126 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-label");
#line 3923 "sudoku-cell.c"
	} else {
#line 128 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-label");
#line 3927 "sudoku-cell.c"
	}
#line 122 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY]);
#line 3931 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_warnings (SudokuCell* self)
{
	gboolean result;
#line 147 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "../src/sudoku-cell.vala"
	result = self->priv->_show_warnings;
#line 147 "../src/sudoku-cell.vala"
	return result;
#line 3944 "sudoku-cell.c"
}

void
sudoku_cell_set_show_warnings (SudokuCell* self,
                               gboolean value)
{
#line 148 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = value;
#line 148 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY]);
#line 3957 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_extra_warnings (SudokuCell* self)
{
	gboolean result;
#line 157 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 157 "../src/sudoku-cell.vala"
	result = self->priv->_show_extra_warnings;
#line 157 "../src/sudoku-cell.vala"
	return result;
#line 3970 "sudoku-cell.c"
}

void
sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                     gboolean value)
{
#line 158 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = value;
#line 161 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 158 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 3985 "sudoku-cell.c"
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/sudoku-cell.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
#line 24 "../src/sudoku-cell.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
#line 24 "../src/sudoku-cell.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_POPOVER_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_POPOVER_PROPERTY] = g_param_spec_object ("popover", "popover", "popover", gtk_popover_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL] = g_signal_new ("will-open-popover", TYPE_SUDOKU_CELL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 232 "../src/sudoku-cell.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
#line 4026 "sudoku-cell.c"
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
	GtkGestureClick* _tmp0_;
	GtkGestureLongPress* _tmp1_;
	GtkEventControllerKey* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel** _tmp4_;
#line 24 "../src/sudoku-cell.vala"
	self->priv = sudoku_cell_get_instance_private (self);
#line 34 "../src/sudoku-cell.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 34 "../src/sudoku-cell.vala"
	self->priv->button_controller = _tmp0_;
#line 35 "../src/sudoku-cell.vala"
	_tmp1_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 35 "../src/sudoku-cell.vala"
	self->priv->long_press_controller = _tmp1_;
#line 36 "../src/sudoku-cell.vala"
	_tmp2_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 36 "../src/sudoku-cell.vala"
	self->priv->key_controller = _tmp2_;
#line 38 "../src/sudoku-cell.vala"
	self->priv->_popover = NULL;
#line 53 "../src/sudoku-cell.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
#line 53 "../src/sudoku-cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 53 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp3_);
#line 53 "../src/sudoku-cell.vala"
	self->priv->value_label = _tmp3_;
#line 56 "../src/sudoku-cell.vala"
	_tmp4_ = g_new0 (GtkLabel*, 8 + 1);
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = _tmp4_;
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels_length1 = 8;
#line 56 "../src/sudoku-cell.vala"
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
#line 91 "../src/sudoku-cell.vala"
	self->priv->_selected = FALSE;
#line 105 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = FALSE;
#line 119 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = FALSE;
#line 144 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = TRUE;
#line 154 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 4080 "sudoku-cell.c"
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
#line 24 "../src/sudoku-cell.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
#line 30 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 34 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 35 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 36 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 38 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->_popover);
#line 53 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
#line 4105 "sudoku-cell.c"
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_POPOVER_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_object (value, sudoku_cell_get_popover (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_int (value, sudoku_cell_get_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_background (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_extra_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 4188 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 4194 "sudoku-cell.c"
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, g_value_get_int (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_background (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_value (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 4244 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 4250 "sudoku-cell.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

